import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcColumnMovingSeparatorComponent = /*@__PURE__*/ (() => {
    class IgcColumnMovingSeparatorComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new ColumnMovingSeparator();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcColumnMovingSeparatorComponent._observedAttributesIgcColumnMovingSeparatorComponent == null) {
                let names = getAllPropertyNames(IgcColumnMovingSeparatorComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcColumnMovingSeparatorComponent._observedAttributesIgcColumnMovingSeparatorComponent = names;
            }
            return IgcColumnMovingSeparatorComponent._observedAttributesIgcColumnMovingSeparatorComponent;
        }
        static register() {
            if (!IgcColumnMovingSeparatorComponent._isElementRegistered) {
                IgcColumnMovingSeparatorComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcColumnMovingSeparatorComponent.htmlTagName, IgcColumnMovingSeparatorComponent);
            }
        }
        /**
         * Gets or sets the separator width for this column.
        */
        get separatorWidth() {
            return this.i.er;
        }
        set separatorWidth(v) {
            this.i.er = +v;
            this._a("separatorWidth", this.i.er);
        }
        get actualOpacity() {
            return this.i.eo;
        }
        set actualOpacity(v) {
            this.i.eo = +v;
            this._a("actualOpacity", this.i.eo);
        }
        get opacity() {
            return this.i.ep;
        }
        set opacity(v) {
            this.i.ep = +v;
            this._a("opacity", this.i.ep);
        }
    }
    IgcColumnMovingSeparatorComponent._observedAttributesIgcColumnMovingSeparatorComponent = null;
    IgcColumnMovingSeparatorComponent.htmlTagName = "igc-column-moving-separator";
    IgcColumnMovingSeparatorComponent._isElementRegistered = false;
    return IgcColumnMovingSeparatorComponent;
})();
