import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { EditRowDefinition } from "./EditRowDefinition";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export let IgcEditRowDefinitionComponent = /*@__PURE__*/ (() => {
    class IgcEditRowDefinitionComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new EditRowDefinition();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent == null) {
                let names = getAllPropertyNames(IgcEditRowDefinitionComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent = names;
            }
            return IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent;
        }
        static register() {
            if (!IgcEditRowDefinitionComponent._isElementRegistered) {
                IgcEditRowDefinitionComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcEditRowDefinitionComponent.htmlTagName, IgcEditRowDefinitionComponent);
            }
        }
    }
    IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent = null;
    IgcEditRowDefinitionComponent.htmlTagName = "igc-edit-row-definition";
    IgcEditRowDefinitionComponent._isElementRegistered = false;
    return IgcEditRowDefinitionComponent;
})();
