import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { EditorDefinition } from "./EditorDefinition";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export let IgcEditorDefinitionComponent = /*@__PURE__*/ (() => {
    class IgcEditorDefinitionComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new EditorDefinition();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent == null) {
                let names = getAllPropertyNames(IgcEditorDefinitionComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent = names;
            }
            return IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent;
        }
        static register() {
            if (!IgcEditorDefinitionComponent._isElementRegistered) {
                IgcEditorDefinitionComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcEditorDefinitionComponent.htmlTagName, IgcEditorDefinitionComponent);
            }
        }
    }
    IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent = null;
    IgcEditorDefinitionComponent.htmlTagName = "igc-editor-definition";
    IgcEditorDefinitionComponent._isElementRegistered = false;
    return IgcEditorDefinitionComponent;
})();
