import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { FilterRowDefinition } from "./FilterRowDefinition";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export let IgcFilterRowDefinitionComponent = /*@__PURE__*/ (() => {
    class IgcFilterRowDefinitionComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new FilterRowDefinition();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent == null) {
                let names = getAllPropertyNames(IgcFilterRowDefinitionComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent = names;
            }
            return IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent;
        }
        static register() {
            if (!IgcFilterRowDefinitionComponent._isElementRegistered) {
                IgcFilterRowDefinitionComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcFilterRowDefinitionComponent.htmlTagName, IgcFilterRowDefinitionComponent);
            }
        }
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get paddingLeft() {
            return this.i.er;
        }
        set paddingLeft(v) {
            this.i.er = +v;
            this._a("paddingLeft", this.i.er);
        }
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get paddingTop() {
            return this.i.et;
        }
        set paddingTop(v) {
            this.i.et = +v;
            this._a("paddingTop", this.i.et);
        }
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get paddingRight() {
            return this.i.es;
        }
        set paddingRight(v) {
            this.i.es = +v;
            this._a("paddingRight", this.i.es);
        }
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get paddingBottom() {
            return this.i.eq;
        }
        set paddingBottom(v) {
            this.i.eq = +v;
            this._a("paddingBottom", this.i.eq);
        }
    }
    IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent = null;
    IgcFilterRowDefinitionComponent.htmlTagName = "igc-filter-row-definition";
    IgcFilterRowDefinitionComponent._isElementRegistered = false;
    return IgcFilterRowDefinitionComponent;
})();
