import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { DataGridColumn as DataGridColumn_internal } from './DataGridColumn';
import { IgcDataGridColumnComponent as IgcDataGridColumnComponent } from './igc-data-grid-column-component';
export class IgcGridColumnCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcDataGridColumnComponent.$type) {
            IgcDataGridColumnComponent.$type = markType(IgcDataGridColumnComponent, "IgcDataGridColumnComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcDataGridColumnComponent.$type) {
            IgcDataGridColumnComponent.$type = markType(IgcDataGridColumnComponent, "IgcDataGridColumnComponent");
        }
        let coll = new SyncableObservableCollection$2(IgcDataGridColumnComponent.$type, DataGridColumn_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgcDataGridColumnComponent._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
