import { NamePatcher, toSpinal, getAllPropertyNames } from "igniteui-webcomponents-core";
import { WebComponentRenderer } from "igniteui-webcomponents-core";
import { DataGridStylingDefaults } from './DataGridStylingDefaults';
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { GridColumnPinOptions } from "./GridColumnPinOptions";
import { IgcGridColumnOptionsSimpleSectionBaseComponent } from "./igc-grid-column-options-simple-section-base-component";
export let IgcGridColumnPinOptionsComponent = /*@__PURE__*/ (() => {
    class IgcGridColumnPinOptionsComponent extends IgcGridColumnOptionsSimpleSectionBaseComponent {
        set height(value) {
            this._height = value;
            this.style.height = value;
        }
        get height() {
            return this._height;
        }
        set width(value) {
            this._width = value;
            this.style.width = value;
        }
        get width() {
            return this._width;
        }
        constructor() {
            super();
            this._disconnected = false;
            if (this._styling) {
                NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._webComponentRenderer = new WebComponentRenderer(this, document, true, DataGridStylingDefaults);
            this._webComponentWrapper = this._webComponentRenderer.createElement("div");
            this._webComponentRenderer.updateRoot(this._webComponentWrapper);
            //this._webComponentRenderer.rootWrapper.append(this._webComponentWrapper);
            this._webComponentWrapper.setStyleProperty("display", "block");
            this._webComponentWrapper.setStyleProperty("width", "100%");
            this._webComponentWrapper.setStyleProperty("height", "100%");
            this.i.provideRenderer(this._webComponentRenderer);
        }
        // supports angular themes or custom properties set in CSS
        updateStyle() {
            this._styling(this, this);
        }
        destroy() {
            this._implementation.destroy();
            this._webComponentRenderer.destroy();
        }
        createImplementation() {
            return new GridColumnPinOptions();
        }
        get i() {
            return this._implementation;
        }
        disconnectedCallback() {
            this._disconnected = true;
        }
        connectedCallback() {
            if (this._disconnected) {
                this._disconnected = false;
                return;
            }
            this.classList.add("ig-grid-column-pin-options");
            this.classList.add("igc-grid-column-pin-options");
            this.appendChild(this._webComponentRenderer.rootWrapper.getNativeElement());
            this._attached = true;
            this.style.display = "block";
            this.style.height = this._height;
            this.style.width = this._width;
            this._flushQueuedAttributes();
            // supports themes or custom properties set in CSS
            this._styling(this, this);
            this.afterContentInit();
        }
        afterContentInit() {
        }
        static get observedAttributes() {
            if (IgcGridColumnPinOptionsComponent._observedAttributesIgcGridColumnPinOptionsComponent == null) {
                let names = getAllPropertyNames(IgcGridColumnPinOptionsComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGridColumnPinOptionsComponent._observedAttributesIgcGridColumnPinOptionsComponent = names;
            }
            return IgcGridColumnPinOptionsComponent._observedAttributesIgcGridColumnPinOptionsComponent;
        }
        static register() {
            if (!IgcGridColumnPinOptionsComponent._isElementRegistered) {
                IgcGridColumnPinOptionsComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcGridColumnPinOptionsComponent.htmlTagName, IgcGridColumnPinOptionsComponent);
            }
        }
        get pinLeftCaption() {
            return this.i.b6;
        }
        set pinLeftCaption(v) {
            this.i.b6 = v;
        }
        get pinRightCaption() {
            return this.i.ca;
        }
        set pinRightCaption(v) {
            this.i.ca = v;
        }
    }
    IgcGridColumnPinOptionsComponent._observedAttributesIgcGridColumnPinOptionsComponent = null;
    IgcGridColumnPinOptionsComponent.htmlTagName = "igc-grid-column-pin-options";
    IgcGridColumnPinOptionsComponent._isElementRegistered = false;
    return IgcGridColumnPinOptionsComponent;
})();
