import { IgcColumnGroupDescriptionCollection } from "./igc-column-group-description-collection";
import { GridGroupDescriptionsChangedEventArgs as GridGroupDescriptionsChangedEventArgs_internal } from "./GridGroupDescriptionsChangedEventArgs";
/**
 * Information about the current grouping applied to the grid.
*/
export class IgcGridGroupDescriptionsChangedEventArgs {
    createImplementation() {
        return new GridGroupDescriptionsChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get groupDescriptions() {
        const r = this.i.groupDescriptions;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgcColumnGroupDescriptionCollection();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set groupDescriptions(v) {
        v == null ? this.i.groupDescriptions = null : this.i.groupDescriptions = v.i;
    }
}
