import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { CellRange as CellRange_internal } from './CellRange';
import { IgcCellRange as IgcCellRange } from './igc-cell-range';
export class IgcGridSelectedCellRangesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcCellRange.$type) {
            IgcCellRange.$type = markType(IgcCellRange, "IgcCellRange");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcCellRange.$type) {
            IgcCellRange.$type = markType(IgcCellRange, "IgcCellRange");
        }
        let coll = new SyncableObservableCollection$2(IgcCellRange.$type, CellRange_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgcCellRange();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
