import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { HeaderSeparator } from "./HeaderSeparator";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcHeaderSeparatorComponent = /*@__PURE__*/ (() => {
    class IgcHeaderSeparatorComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new HeaderSeparator();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcHeaderSeparatorComponent._observedAttributesIgcHeaderSeparatorComponent == null) {
                let names = getAllPropertyNames(IgcHeaderSeparatorComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcHeaderSeparatorComponent._observedAttributesIgcHeaderSeparatorComponent = names;
            }
            return IgcHeaderSeparatorComponent._observedAttributesIgcHeaderSeparatorComponent;
        }
        static register() {
            if (!IgcHeaderSeparatorComponent._isElementRegistered) {
                IgcHeaderSeparatorComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcHeaderSeparatorComponent.htmlTagName, IgcHeaderSeparatorComponent);
            }
        }
    }
    IgcHeaderSeparatorComponent._observedAttributesIgcHeaderSeparatorComponent = null;
    IgcHeaderSeparatorComponent.htmlTagName = "igc-header-separator";
    IgcHeaderSeparatorComponent._isElementRegistered = false;
    return IgcHeaderSeparatorComponent;
})();
