import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { RowSeparator } from "./RowSeparator";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
export let IgcRowSeparatorComponent = /*@__PURE__*/ (() => {
    class IgcRowSeparatorComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new RowSeparator();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent == null) {
                let names = getAllPropertyNames(IgcRowSeparatorComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent = names;
            }
            return IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent;
        }
        static register() {
            if (!IgcRowSeparatorComponent._isElementRegistered) {
                IgcRowSeparatorComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcRowSeparatorComponent.htmlTagName, IgcRowSeparatorComponent);
            }
        }
    }
    IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent = null;
    IgcRowSeparatorComponent.htmlTagName = "igc-row-separator";
    IgcRowSeparatorComponent._isElementRegistered = false;
    return IgcRowSeparatorComponent;
})();
