import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { SectionFooter } from "./SectionFooter";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Used to configure the appearance of the section footer cells.
*/
export let IgcSectionFooterComponent = /*@__PURE__*/ (() => {
    class IgcSectionFooterComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new SectionFooter();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcSectionFooterComponent._observedAttributesIgcSectionFooterComponent == null) {
                let names = getAllPropertyNames(IgcSectionFooterComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcSectionFooterComponent._observedAttributesIgcSectionFooterComponent = names;
            }
            return IgcSectionFooterComponent._observedAttributesIgcSectionFooterComponent;
        }
        static register() {
            if (!IgcSectionFooterComponent._isElementRegistered) {
                IgcSectionFooterComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcSectionFooterComponent.htmlTagName, IgcSectionFooterComponent);
            }
        }
    }
    IgcSectionFooterComponent._observedAttributesIgcSectionFooterComponent = null;
    IgcSectionFooterComponent.htmlTagName = "igc-section-footer";
    IgcSectionFooterComponent._isElementRegistered = false;
    return IgcSectionFooterComponent;
})();
