import { GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { SectionHeader } from "./SectionHeader";
import { getAllPropertyNames, toSpinal, brushToString, stringToBrush, ensureBool, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Used to configure the appearance of the section header cells.
*/
export let IgcSectionHeaderComponent = /*@__PURE__*/ (() => {
    class IgcSectionHeaderComponent extends IgcDefinitionBaseComponent {
        createImplementation() {
            return new SectionHeader();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent == null) {
                let names = getAllPropertyNames(IgcSectionHeaderComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent = names;
            }
            return IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent;
        }
        static register() {
            if (!IgcSectionHeaderComponent._isElementRegistered) {
                IgcSectionHeaderComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcSectionHeaderComponent.htmlTagName, IgcSectionHeaderComponent);
            }
        }
        get selectedBackground() {
            return brushToString(this.i.fg);
        }
        set selectedBackground(v) {
            this.i.fg = stringToBrush(v);
            this._a("selectedBackground", brushToString(this.i.fg));
        }
        get actualSelectedBackground() {
            return brushToString(this.i.ff);
        }
        set actualSelectedBackground(v) {
            this.i.ff = stringToBrush(v);
            this._a("actualSelectedBackground", brushToString(this.i.ff));
        }
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get paddingLeft() {
            return this.i.ey;
        }
        set paddingLeft(v) {
            this.i.ey = +v;
            this._a("paddingLeft", this.i.ey);
        }
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get paddingTop() {
            return this.i.e0;
        }
        set paddingTop(v) {
            this.i.e0 = +v;
            this._a("paddingTop", this.i.e0);
        }
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get paddingRight() {
            return this.i.ez;
        }
        set paddingRight(v) {
            this.i.ez = +v;
            this._a("paddingRight", this.i.ez);
        }
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get paddingBottom() {
            return this.i.ex;
        }
        set paddingBottom(v) {
            this.i.ex = +v;
            this._a("paddingBottom", this.i.ex);
        }
        get isCollapsable() {
            return this.i.er;
        }
        set isCollapsable(v) {
            this.i.er = ensureBool(v);
            this._a("isCollapsable", this.i.er);
        }
        get summaryDisplayMode() {
            return this.i.eo;
        }
        set summaryDisplayMode(v) {
            this.i.eo = ensureEnum(GroupSummaryDisplayMode_$type, v);
            this._a("summaryDisplayMode", enumToString(GroupSummaryDisplayMode_$type, this.i.eo));
        }
    }
    IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent = null;
    IgcSectionHeaderComponent.htmlTagName = "igc-section-header";
    IgcSectionHeaderComponent._isElementRegistered = false;
    return IgcSectionHeaderComponent;
})();
