import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { getAllPropertyNames, toSpinal, brushToString, stringToBrush } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
export let IgcSummaryRowComponent = /*@__PURE__*/ (() => {
    class IgcSummaryRowComponent extends IgcDefinitionBaseComponent {
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent == null) {
                let names = getAllPropertyNames(IgcSummaryRowComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent = names;
            }
            return IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent;
        }
        /**
         * Gets or sets the background color for summary cells when selected.
        */
        get selectedBackground() {
            return brushToString(this.i.fj);
        }
        set selectedBackground(v) {
            this.i.fj = stringToBrush(v);
            this._a("selectedBackground", brushToString(this.i.fj));
        }
        /**
         * Gets the actual background color for summary cells when selected.
        */
        get actualSelectedBackground() {
            return brushToString(this.i.fg);
        }
        set actualSelectedBackground(v) {
            this.i.fg = stringToBrush(v);
            this._a("actualSelectedBackground", brushToString(this.i.fg));
        }
        /**
         * Gets or sets the text color for the summary labels.
        */
        get summaryLabelTextColor() {
            return brushToString(this.i.fk);
        }
        set summaryLabelTextColor(v) {
            this.i.fk = stringToBrush(v);
            this._a("summaryLabelTextColor", brushToString(this.i.fk));
        }
        /**
         * Gets the actual text color for the summary labels.
        */
        get actualSummaryLabelTextColor() {
            return brushToString(this.i.fh);
        }
        set actualSummaryLabelTextColor(v) {
            this.i.fh = stringToBrush(v);
            this._a("actualSummaryLabelTextColor", brushToString(this.i.fh));
        }
        /**
         * Gets or sets the text style for the summary labels.
        */
        get summaryNameTextStyle() {
            if (this.i.summaryNameTextStyle == null) {
                return null;
            }
            return this.i.summaryNameTextStyle.fontString;
        }
        set summaryNameTextStyle(v) {
            let fi = new FontInfo();
            fi.fontString = v;
            this.i.summaryNameTextStyle = fi;
            this._a("summaryNameTextStyle", this.i.summaryNameTextStyle != null ? this.i.summaryNameTextStyle.fontString : "");
        }
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get paddingLeft() {
            return this.i.ew;
        }
        set paddingLeft(v) {
            this.i.ew = +v;
            this._a("paddingLeft", this.i.ew);
        }
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get paddingTop() {
            return this.i.ey;
        }
        set paddingTop(v) {
            this.i.ey = +v;
            this._a("paddingTop", this.i.ey);
        }
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get paddingRight() {
            return this.i.ex;
        }
        set paddingRight(v) {
            this.i.ex = +v;
            this._a("paddingRight", this.i.ex);
        }
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get paddingBottom() {
            return this.i.ev;
        }
        set paddingBottom(v) {
            this.i.ev = +v;
            this._a("paddingBottom", this.i.ev);
        }
    }
    IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent = null;
    return IgcSummaryRowComponent;
})();
