import { EditorType_$type } from "./EditorType";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { TextColumn } from "./TextColumn";
import { getAllPropertyNames, toSpinal, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export let IgcTextColumnComponent = /*@__PURE__*/ (() => {
    class IgcTextColumnComponent extends IgcDataGridColumnComponent {
        createImplementation() {
            return new TextColumn();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcTextColumnComponent._observedAttributesIgcTextColumnComponent == null) {
                let names = getAllPropertyNames(IgcTextColumnComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcTextColumnComponent._observedAttributesIgcTextColumnComponent = names;
            }
            return IgcTextColumnComponent._observedAttributesIgcTextColumnComponent;
        }
        static register() {
            if (!IgcTextColumnComponent._isElementRegistered) {
                IgcTextColumnComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcTextColumnComponent.htmlTagName, IgcTextColumnComponent);
            }
        }
        /**
         * Gets or sets the editor type used for editing cells in this column.
        */
        get editorType() {
            return this.i.ll;
        }
        set editorType(v) {
            this.i.ll = ensureEnum(EditorType_$type, v);
            this._a("editorType", enumToString(EditorType_$type, this.i.ll));
        }
        /**
         * Gets or sets the ComboBox data source.
        */
        get editorDataSource() {
            return this.i.lm;
        }
        set editorDataSource(v) {
            this.i.lm = v;
        }
        /**
         * Gets or sets the ComboBox text field.
        */
        get editorTextField() {
            return this.i.lo;
        }
        set editorTextField(v) {
            this.i.lo = v;
        }
        /**
         * Gets or sets the ComboBox value field.
        */
        get editorValueField() {
            return this.i.lp;
        }
        set editorValueField(v) {
            this.i.lp = v;
        }
    }
    IgcTextColumnComponent._observedAttributesIgcTextColumnComponent = null;
    IgcTextColumnComponent.htmlTagName = "igc-text-column";
    IgcTextColumnComponent._isElementRegistered = false;
    return IgcTextColumnComponent;
})();
