import { IgcHeaderComponent } from "./igc-header-component";
import { TextHeader } from "./TextHeader";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a class used to configure the appearance of a text column header cells.
*/
export let IgcTextHeaderComponent = /*@__PURE__*/ (() => {
    class IgcTextHeaderComponent extends IgcHeaderComponent {
        createImplementation() {
            return new TextHeader();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent == null) {
                let names = getAllPropertyNames(IgcTextHeaderComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent = names;
            }
            return IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent;
        }
        static register() {
            if (!IgcTextHeaderComponent._isElementRegistered) {
                IgcTextHeaderComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcTextHeaderComponent.htmlTagName, IgcTextHeaderComponent);
            }
        }
    }
    IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent = null;
    IgcTextHeaderComponent.htmlTagName = "igc-text-header";
    IgcTextHeaderComponent._isElementRegistered = false;
    return IgcTextHeaderComponent;
})();
