import { ColumnExchanger as ColumnExchanger_internal } from "./ColumnExchanger";
/**
 * Indicates a column that should be exchanged with another.
*/
var IgcColumnExchanger = /** @class */ /*@__PURE__*/ (function () {
    function IgcColumnExchanger() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcColumnExchanger.prototype.createImplementation = function () {
        return new ColumnExchanger_internal(0);
    };
    Object.defineProperty(IgcColumnExchanger.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcColumnExchanger.prototype.onImplementationCreated = function () {
    };
    IgcColumnExchanger.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcColumnExchanger.prototype, "targetIndex", {
        /**
         * The desired location of the new column
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgcColumnExchanger.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgcColumnExchanger;
}());
export { IgcColumnExchanger };
