import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { PinnedPositions_$type } from "./PinnedPositions";
import { ColumnPinnedChangedEventArgs as ColumnPinnedChangedEventArgs_internal } from "./ColumnPinnedChangedEventArgs";
import { ensureEnum } from "igniteui-webcomponents-core";
/**
 * Event arguments for the ColumnPinnedChanged event.
*/
var IgcColumnPinnedChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcColumnPinnedChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcColumnPinnedChangedEventArgs.prototype.createImplementation = function () {
        return new ColumnPinnedChangedEventArgs_internal();
    };
    Object.defineProperty(IgcColumnPinnedChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcColumnPinnedChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcColumnPinnedChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcColumnPinnedChangedEventArgs.prototype, "column", {
        /**
         * The column whose pinned state has changed.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcDataGridColumnComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcColumnPinnedChangedEventArgs.prototype, "pinned", {
        /**
         * The new pinned state for the column.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(PinnedPositions_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgcColumnPinnedChangedEventArgs;
}());
export { IgcColumnPinnedChangedEventArgs };
