import { ColumnPropertySetter as ColumnPropertySetter_internal } from "./ColumnPropertySetter";
/**
 * Indicates that a specified column should have a specified property set to a value.
*/
var IgcColumnPropertySetter = /** @class */ /*@__PURE__*/ (function () {
    function IgcColumnPropertySetter() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcColumnPropertySetter.prototype.createImplementation = function () {
        return new ColumnPropertySetter_internal(0);
    };
    Object.defineProperty(IgcColumnPropertySetter.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcColumnPropertySetter.prototype.onImplementationCreated = function () {
    };
    IgcColumnPropertySetter.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcColumnPropertySetter.prototype, "columnName", {
        /**
         * The name or key of the column to change the property of
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcColumnPropertySetter.prototype, "propertyName", {
        /**
         * The name of the property to change
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcColumnPropertySetter.prototype, "value", {
        /**
         * The new value of the property
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcColumnPropertySetter.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgcColumnPropertySetter;
}());
export { IgcColumnPropertySetter };
