import { __extends } from "tslib";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { IgcGridColumnAnimationSettings } from "./igc-grid-column-animation-settings";
import { IgcColumnWidth } from "./igc-column-width";
import { IgcHeaderComponent } from "./igc-header-component";
import { ColumnSortDirection_$type } from "./ColumnSortDirection";
import { PinnedPositions_$type } from "./PinnedPositions";
import { ColumnOptionsIconAlignment_$type } from "./ColumnOptionsIconAlignment";
import { ColumnOptionsIconBehavior_$type } from "./ColumnOptionsIconBehavior";
import { MergedCellMode_$type } from "./MergedCellMode";
import { MergedCellEvaluationCriteria_$type } from "./MergedCellEvaluationCriteria";
import { CellContentVerticalAlignment_$type } from "./CellContentVerticalAlignment";
import { FilterComparisonType_$type } from "./FilterComparisonType";
import { IgcGridFilterOperandsCollection } from "./igc-grid-filter-operands-collection";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { getAllPropertyNames, toSpinal, brushToString, stringToBrush, ensureBool, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { ColumnWidth as ColumnWidth_internal } from "./ColumnWidth";
import { FontInfo } from "igniteui-webcomponents-core";
import { GridFilterOperandsCollection as GridFilterOperandsCollection_internal } from "./GridFilterOperandsCollection";
import { FilterOperand } from "./FilterOperand";
import { SyncableObservableCollection$1 } from "igniteui-webcomponents-core";
/**
 * A column in the data grid.
*/
var IgcDataGridColumnComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcDataGridColumnComponent, _super);
    function IgcDataGridColumnComponent() {
        var _this = _super.call(this) || this;
        _this._filterOperands = null;
        _this._actualHeaderTextChange = null;
        _this._actualHeaderTextChange_wrapped = null;
        return _this;
    }
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcDataGridColumnComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcDataGridColumnComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcDataGridColumnComponent, "observedAttributes", {
        get: function () {
            if (IgcDataGridColumnComponent._observedAttributesIgcDataGridColumnComponent == null) {
                var names = getAllPropertyNames(IgcDataGridColumnComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcDataGridColumnComponent._observedAttributesIgcDataGridColumnComponent = names;
            }
            return IgcDataGridColumnComponent._observedAttributesIgcDataGridColumnComponent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.h2;
        },
        set: function (v) {
            this.i.h2 = +v;
            this._a("paddingLeft", this.i.h2);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.h4;
        },
        set: function (v) {
            this.i.h4 = +v;
            this._a("paddingTop", this.i.h4);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.h3;
        },
        set: function (v) {
            this.i.h3 = +v;
            this._a("paddingRight", this.i.h3);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.h1;
        },
        set: function (v) {
            this.i.h1 = +v;
            this._a("paddingBottom", this.i.h1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "name", {
        /**
         * Gets or sets an unique name of the Column
        */
        get: function () {
            return this.i.jz;
        },
        set: function (v) {
            this.i.jz = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "field", {
        /**
         * Gets or sets the key used for the column binding
        */
        get: function () {
            return this.i.i8;
        },
        set: function (v) {
            this.i.i8 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "headerText", {
        /**
         * Gets or sets the text displayed in the header of the column
        */
        get: function () {
            return this.i.jf;
        },
        set: function (v) {
            this.i.jf = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualHeaderText", {
        /**
         * Gets the actual text displayed in the header of the column
        */
        get: function () {
            return this.i.im;
        },
        set: function (v) {
            this.i.im = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "selectedBackground", {
        /**
         * Gets or sets the background color to use for the cells when they are selected
        */
        get: function () {
            return brushToString(this.i.lk);
        },
        set: function (v) {
            this.i.lk = stringToBrush(v);
            this._a("selectedBackground", brushToString(this.i.lk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualSelectedBackground", {
        /**
         * Gets the actual background color that is used for the cells when they are selected
        */
        get: function () {
            return brushToString(this.i.ld);
        },
        set: function (v) {
            this.i.ld = stringToBrush(v);
            this._a("actualSelectedBackground", brushToString(this.i.ld));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "rowHoverBackground", {
        /**
         * Gets or sets the background color to use for the cells when the row is hovered.
        */
        get: function () {
            return brushToString(this.i.li);
        },
        set: function (v) {
            this.i.li = stringToBrush(v);
            this._a("rowHoverBackground", brushToString(this.i.li));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualHoverBackground", {
        /**
         * Gets the actual background color that is used for the cells when they are hovered.
        */
        get: function () {
            return brushToString(this.i.lb);
        },
        set: function (v) {
            this.i.lb = stringToBrush(v);
            this._a("actualHoverBackground", brushToString(this.i.lb));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "rowHoverTextColor", {
        /**
         * Gets or sets the text color to use for the cells when the row is hovered.
        */
        get: function () {
            return brushToString(this.i.lj);
        },
        set: function (v) {
            this.i.lj = stringToBrush(v);
            this._a("rowHoverTextColor", brushToString(this.i.lj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualRowHoverTextColor", {
        /**
         * Gets the actual text color that is used for the cells when they are hovered.
        */
        get: function () {
            return brushToString(this.i.lc);
        },
        set: function (v) {
            this.i.lc = stringToBrush(v);
            this._a("actualRowHoverTextColor", brushToString(this.i.lc));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "animationSettings", {
        /**
         * Gets or sets the animation settings to use for this column.
        */
        get: function () {
            var r = this.i.fs;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcGridColumnAnimationSettings();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.fs = null : this.i.fs = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "width", {
        /**
         * Gets or sets the width to use for this column.
        */
        get: function () {
            var r = this.i.width;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcColumnWidth();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            if (typeof v == "string") {
                var int = ColumnWidth_internal.parse(v);
                var ext = new IgcColumnWidth();
                ext._implementation = int;
                v = ext;
            }
            v == null ? this.i.width = null : this.i.width = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "minWidth", {
        /**
         * Gets or sets the minimum width to use for this column. Overrides the DefaultColumnMinWidth from the grid, if set.
        */
        get: function () {
            return this.i.hi;
        },
        set: function (v) {
            this.i.hi = +v;
            this._a("minWidth", this.i.hi);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isFromMarkup", {
        /**
         * Gets whether this column was projected from markup/templates and is constrained.
        */
        get: function () {
            return this.i.g6;
        },
        set: function (v) {
            this.i.g6 = ensureBool(v);
            this._a("isFromMarkup", this.i.g6);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isAutoGenerated", {
        /**
         * Gets whether this column was auto generated.
        */
        get: function () {
            return this.i.g0;
        },
        set: function (v) {
            this.i.g0 = ensureBool(v);
            this._a("isAutoGenerated", this.i.g0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "filter", {
        /**
         * Gets or sets a filter to apply on the values of this column
        */
        get: function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "filterExpression", {
        /**
         * Gets or sets a filter to apply to the values of this column.
        */
        get: function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "header", {
        /**
         * Gets or sets the header definition for this column.
        */
        get: function () {
            var r = this.i.header;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcHeaderComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.header = null : this.i.header = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isFilteringEnabled", {
        /**
         * Gets or sets whether filtering is enabled for this column.
        */
        get: function () {
            return this.i.g5;
        },
        set: function (v) {
            this.i.g5 = ensureBool(v);
            this._a("isFilteringEnabled", this.i.g5);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isResizingEnabled", {
        /**
         * Gets or sets whether resizing is enabled for this column.
        */
        get: function () {
            return this.i.g8;
        },
        set: function (v) {
            this.i.g8 = ensureBool(v);
            this._a("isResizingEnabled", this.i.g8);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isHidden", {
        /**
         * Gets or sets whether or not a column is hidden from the grid
        */
        get: function () {
            return this.i.g7;
        },
        set: function (v) {
            this.i.g7 = ensureBool(v);
            this._a("isHidden", this.i.g7);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "shouldRemoveWhenHidden", {
        /**
         * Gets or sets if a column should be removed from the grid when it is fully hidden
        */
        get: function () {
            return this.i.hb;
        },
        set: function (v) {
            this.i.hb = ensureBool(v);
            this._a("shouldRemoveWhenHidden", this.i.hb);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "sortDirection", {
        /**
         * Gets the current sort direction (None, Ascending, Descending) for this column.
        */
        get: function () {
            return this.i.ff;
        },
        set: function (v) {
            this.i.ff = ensureEnum(ColumnSortDirection_$type, v);
            this._a("sortDirection", enumToString(ColumnSortDirection_$type, this.i.ff));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "pinned", {
        /**
         * Gets or sets the current fixed position for this column.
        */
        get: function () {
            return this.i.f6;
        },
        set: function (v) {
            this.i.f6 = ensureEnum(PinnedPositions_$type, v);
            this._a("pinned", enumToString(PinnedPositions_$type, this.i.f6));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualColumnOptionsIconAlignment", {
        /**
         * Gets the actual column options icon alignment for this column.
        */
        get: function () {
            return this.i.e6;
        },
        set: function (v) {
            this.i.e6 = ensureEnum(ColumnOptionsIconAlignment_$type, v);
            this._a("actualColumnOptionsIconAlignment", enumToString(ColumnOptionsIconAlignment_$type, this.i.e6));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "columnOptionsIconAlignment", {
        /**
         * Gets or sets whether the column options icon is aligned opposite the header text or not.
        */
        get: function () {
            return this.i.e7;
        },
        set: function (v) {
            this.i.e7 = ensureEnum(ColumnOptionsIconAlignment_$type, v);
            this._a("columnOptionsIconAlignment", enumToString(ColumnOptionsIconAlignment_$type, this.i.e7));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualColumnOptionsIconColor", {
        /**
         * Gets the actual column options icon color for this column.
        */
        get: function () {
            return brushToString(this.i.k9);
        },
        set: function (v) {
            this.i.k9 = stringToBrush(v);
            this._a("actualColumnOptionsIconColor", brushToString(this.i.k9));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "columnOptionsIconColor", {
        /**
         * Gets or sets the column options icon color for this column.
        */
        get: function () {
            return brushToString(this.i.le);
        },
        set: function (v) {
            this.i.le = stringToBrush(v);
            this._a("columnOptionsIconColor", brushToString(this.i.le));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "columnOptionsIconBehavior", {
        /**
         * Gets or sets how the column option icon will behave in the column header.
        */
        get: function () {
            return this.i.fb;
        },
        set: function (v) {
            this.i.fb = ensureEnum(ColumnOptionsIconBehavior_$type, v);
            this._a("columnOptionsIconBehavior", enumToString(ColumnOptionsIconBehavior_$type, this.i.fb));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualColumnOptionsIconBehavior", {
        /**
         * Gets or sets how the column option icon will behave in the column header.
        */
        get: function () {
            return this.i.fa;
        },
        set: function (v) {
            this.i.fa = ensureEnum(ColumnOptionsIconBehavior_$type, v);
            this._a("actualColumnOptionsIconBehavior", enumToString(ColumnOptionsIconBehavior_$type, this.i.fa));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualIsColumnOptionsEnabled", {
        /**
         * Gets the actual state of the column options for this column.
        */
        get: function () {
            return this.i.gt;
        },
        set: function (v) {
            this.i.gt = ensureBool(v);
            this._a("actualIsColumnOptionsEnabled", this.i.gt);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isColumnOptionsEnabled", {
        /**
         * Gets or sets the preferred state of the column options for this column. If the feature is disabled at the grid level
         * then it will be disabled for the column regardless of what this is set to.
        */
        get: function () {
            return this.i.g1;
        },
        set: function (v) {
            this.i.g1 = ensureBool(v);
            this._a("isColumnOptionsEnabled", this.i.g1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualIsColumnOptionsSummariesEnabled", {
        /**
         * Gets the actual state of summaries menu in the column options for this column.
        */
        get: function () {
            return this.i.gv;
        },
        set: function (v) {
            this.i.gv = ensureBool(v);
            this._a("actualIsColumnOptionsSummariesEnabled", this.i.gv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isColumnOptionsSummariesEnabled", {
        /**
         * Gets or sets whether to show the summaries option in the column options menu for this column.
        */
        get: function () {
            return this.i.g3;
        },
        set: function (v) {
            this.i.g3 = ensureBool(v);
            this._a("isColumnOptionsSummariesEnabled", this.i.g3);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualIsColumnOptionsGroupingEnabled", {
        /**
         * Gets the actual state of grouping menu in the column options for this column.
        */
        get: function () {
            return this.i.gu;
        },
        set: function (v) {
            this.i.gu = ensureBool(v);
            this._a("actualIsColumnOptionsGroupingEnabled", this.i.gu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isColumnOptionsGroupingEnabled", {
        /**
         * Gets or sets whether to show the grouping option in the column options menu for this column.
        */
        get: function () {
            return this.i.g2;
        },
        set: function (v) {
            this.i.g2 = ensureBool(v);
            this._a("isColumnOptionsGroupingEnabled", this.i.g2);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "isEditable", {
        /**
         * Gets or sets if the column is editable.
        */
        get: function () {
            return this.i.g4;
        },
        set: function (v) {
            this.i.g4 = ensureBool(v);
            this._a("isEditable", this.i.g4);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "deletedTextColor", {
        /**
         * Gets or sets the text color used for deleted rows.
        */
        get: function () {
            return brushToString(this.i.lf);
        },
        set: function (v) {
            this.i.lf = stringToBrush(v);
            this._a("deletedTextColor", brushToString(this.i.lf));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualDeletedTextColor", {
        /**
         * Gets the actual text color used for deleted rows.
        */
        get: function () {
            return brushToString(this.i.la);
        },
        set: function (v) {
            this.i.la = stringToBrush(v);
            this._a("actualDeletedTextColor", brushToString(this.i.la));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "editOpacity", {
        /**
         * Gets or sets the opacity to use for unsaved edited cell values.
        */
        get: function () {
            return this.i.hh;
        },
        set: function (v) {
            this.i.hh = +v;
            this._a("editOpacity", this.i.hh);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualEditOpacity", {
        /**
         * Gets the actual opacity for unsaved edited cell values.
        */
        get: function () {
            return this.i.hg;
        },
        set: function (v) {
            this.i.hg = +v;
            this._a("actualEditOpacity", this.i.hg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "textEditStyle", {
        /**
         * Gets or sets the font style to use for unsaved cell edits.
        */
        get: function () {
            if (this.i.textEditStyle == null) {
                return null;
            }
            return this.i.textEditStyle.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.textEditStyle = fi;
            this._a("textEditStyle", this.i.textEditStyle != null ? this.i.textEditStyle.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualEditFontInfo", {
        /**
         * Gets the actual font style used for unsaved cell edits.
        */
        get: function () {
            if (this.i.gb == null) {
                return null;
            }
            return this.i.gb.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.gb = fi;
            this._a("actualEditFontInfo", this.i.gb != null ? this.i.gb.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellMode", {
        /**
         * Gets or sets if and how cell merging is performed for this field.
        */
        get: function () {
            return this.i.f2;
        },
        set: function (v) {
            this.i.f2 = ensureEnum(MergedCellMode_$type, v);
            this._a("mergedCellMode", enumToString(MergedCellMode_$type, this.i.f2));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellEvaluationCriteria", {
        /**
         * Gets or sets how cells are evaluated for merging.
        */
        get: function () {
            return this.i.fz;
        },
        set: function (v) {
            this.i.fz = ensureEnum(MergedCellEvaluationCriteria_$type, v);
            this._a("mergedCellEvaluationCriteria", enumToString(MergedCellEvaluationCriteria_$type, this.i.fz));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment to use for the merged cell content.
        */
        get: function () {
            return this.i.ey;
        },
        set: function (v) {
            this.i.ey = ensureEnum(CellContentVerticalAlignment_$type, v);
            this._a("mergedCellVerticalAlignment", enumToString(CellContentVerticalAlignment_$type, this.i.ey));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellPaddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.hv;
        },
        set: function (v) {
            this.i.hv = +v;
            this._a("mergedCellPaddingLeft", this.i.hv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellPaddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.hx;
        },
        set: function (v) {
            this.i.hx = +v;
            this._a("mergedCellPaddingTop", this.i.hx);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellPaddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.hw;
        },
        set: function (v) {
            this.i.hw = +v;
            this._a("mergedCellPaddingRight", this.i.hw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "mergedCellPaddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.hu;
        },
        set: function (v) {
            this.i.hu = +v;
            this._a("mergedCellPaddingBottom", this.i.hu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "filterComparisonType", {
        /**
         * Gets or sets whether UI filters are case sensitive or not.
        */
        get: function () {
            return this.i.fn;
        },
        set: function (v) {
            this.i.fn = ensureEnum(FilterComparisonType_$type, v);
            this._a("filterComparisonType", enumToString(FilterComparisonType_$type, this.i.fn));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "filterOperands", {
        /**
         * Gets a list of the current custom filters for this column.
        */
        get: function () {
            if (this._filterOperands === null) {
                var coll = new IgcGridFilterOperandsCollection();
                var innerColl = this.i.fu;
                if (!innerColl) {
                    innerColl = new GridFilterOperandsCollection_internal();
                }
                this._filterOperands = coll._fromInner(innerColl);
            }
            return this._filterOperands;
        },
        set: function (v) {
            if (this._filterOperands !== null) {
                this._filterOperands._setSyncTarget(null);
                this._filterOperands = null;
            }
            var coll = new IgcGridFilterOperandsCollection();
            this._filterOperands = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(FilterOperand.$type);
            var innerColl = this.i.fu;
            if (!innerColl) {
                innerColl = new GridFilterOperandsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._filterOperands._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    IgcDataGridColumnComponent.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.animationSettings && this.animationSettings.name && this.animationSettings.name == name) {
            return this.animationSettings;
        }
        if (this.width && this.width.name && this.width.name == name) {
            return this.width;
        }
        if (this.header && this.header.name && this.header.name == name) {
            return this.header;
        }
        if (this.filterOperands != null && this.filterOperands.findByName && this.filterOperands.findByName(name)) {
            return this.filterOperands.findByName(name);
        }
        return null;
    };
    IgcDataGridColumnComponent.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.header && this.header._styling) {
            this.header._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Get the unique key used to identify this column.
    
    */
    IgcDataGridColumnComponent.prototype.getUniqueKey = function () {
        var iv = this.i.jd();
        return (iv);
    };
    IgcDataGridColumnComponent.prototype.setNamedHeaderValue = function (valueName, animationType, value) {
        this.i.kk(valueName, (animationType == null ? null : animationType), value);
    };
    /**
     * Returns if the column has named header values.
    
    */
    IgcDataGridColumnComponent.prototype.hasNamedHeaderValues = function () {
        var iv = this.i.gy();
        return (iv);
    };
    /**
     * Returns if there is a named header value with a given name.
    
    * @param valueName  * The named value to check for.
    */
    IgcDataGridColumnComponent.prototype.hasNamedHeaderValue = function (valueName) {
        var iv = this.i.gx(valueName);
        return (iv);
    };
    /**
     * Removes a named header value with the given name from the named header values for this column.
    
    * @param valueName  * The named header value to remove.
    */
    IgcDataGridColumnComponent.prototype.removeNamedHeaderValue = function (valueName) {
        this.i.kj(valueName);
    };
    /**
     * Gets the value of a named header value for this column by name.
    
    * @param valueName  * Name of the named header value to retrieve.
    */
    IgcDataGridColumnComponent.prototype.getNamedHeaderValue = function (valueName) {
        var iv = this.i.h9(valueName);
        return (iv);
    };
    IgcDataGridColumnComponent.prototype.applyCustomFilter = function (filterID, index, value) {
        this.i.ke(filterID, index, value);
    };
    Object.defineProperty(IgcDataGridColumnComponent.prototype, "actualHeaderTextChange", {
        get: function () {
            return this._actualHeaderTextChange;
        },
        set: function (ev) {
            var _this = this;
            if (this._actualHeaderTextChange_wrapped !== null) {
                this.i.propertyChanged = delegateRemove(this.i.propertyChanged, this._actualHeaderTextChange_wrapped);
                this._actualHeaderTextChange_wrapped = null;
                this._actualHeaderTextChange = null;
            }
            this._actualHeaderTextChange = ev;
            this._actualHeaderTextChange_wrapped = function (o, e) {
                var ext = _this.actualHeaderText;
                if (e.propertyName == 'Im') {
                    if (_this.beforeActualHeaderTextChange) {
                        _this.beforeActualHeaderTextChange(_this, ext);
                    }
                    if (_this._actualHeaderTextChange) {
                        _this._actualHeaderTextChange(_this, ext);
                    }
                }
            };
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, this._actualHeaderTextChange_wrapped);
        },
        enumerable: false,
        configurable: true
    });
    IgcDataGridColumnComponent._observedAttributesIgcDataGridColumnComponent = null;
    return IgcDataGridColumnComponent;
}(IgcDefinitionBaseComponent));
export { IgcDataGridColumnComponent };
