import { __extends } from "tslib";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { EditRowDefinition } from "./EditRowDefinition";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
var IgcEditRowDefinitionComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcEditRowDefinitionComponent, _super);
    function IgcEditRowDefinitionComponent() {
        return _super.call(this) || this;
    }
    IgcEditRowDefinitionComponent.prototype.createImplementation = function () {
        return new EditRowDefinition();
    };
    Object.defineProperty(IgcEditRowDefinitionComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcEditRowDefinitionComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcEditRowDefinitionComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcEditRowDefinitionComponent, "observedAttributes", {
        get: function () {
            if (IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent == null) {
                var names = getAllPropertyNames(IgcEditRowDefinitionComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent = names;
            }
            return IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcEditRowDefinitionComponent.register = function () {
        if (!IgcEditRowDefinitionComponent._isElementRegistered) {
            IgcEditRowDefinitionComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcEditRowDefinitionComponent.htmlTagName, IgcEditRowDefinitionComponent);
        }
    };
    IgcEditRowDefinitionComponent._observedAttributesIgcEditRowDefinitionComponent = null;
    IgcEditRowDefinitionComponent.htmlTagName = "igc-edit-row-definition";
    IgcEditRowDefinitionComponent._isElementRegistered = false;
    return IgcEditRowDefinitionComponent;
}(IgcDefinitionBaseComponent));
export { IgcEditRowDefinitionComponent };
