import { __extends } from "tslib";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { EditorDefinition } from "./EditorDefinition";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
var IgcEditorDefinitionComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcEditorDefinitionComponent, _super);
    function IgcEditorDefinitionComponent() {
        return _super.call(this) || this;
    }
    IgcEditorDefinitionComponent.prototype.createImplementation = function () {
        return new EditorDefinition();
    };
    Object.defineProperty(IgcEditorDefinitionComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcEditorDefinitionComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcEditorDefinitionComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcEditorDefinitionComponent, "observedAttributes", {
        get: function () {
            if (IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent == null) {
                var names = getAllPropertyNames(IgcEditorDefinitionComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent = names;
            }
            return IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcEditorDefinitionComponent.register = function () {
        if (!IgcEditorDefinitionComponent._isElementRegistered) {
            IgcEditorDefinitionComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcEditorDefinitionComponent.htmlTagName, IgcEditorDefinitionComponent);
        }
    };
    IgcEditorDefinitionComponent._observedAttributesIgcEditorDefinitionComponent = null;
    IgcEditorDefinitionComponent.htmlTagName = "igc-editor-definition";
    IgcEditorDefinitionComponent._isElementRegistered = false;
    return IgcEditorDefinitionComponent;
}(IgcDefinitionBaseComponent));
export { IgcEditorDefinitionComponent };
