import { __extends } from "tslib";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { FilterRowDefinition } from "./FilterRowDefinition";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
var IgcFilterRowDefinitionComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcFilterRowDefinitionComponent, _super);
    function IgcFilterRowDefinitionComponent() {
        return _super.call(this) || this;
    }
    IgcFilterRowDefinitionComponent.prototype.createImplementation = function () {
        return new FilterRowDefinition();
    };
    Object.defineProperty(IgcFilterRowDefinitionComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcFilterRowDefinitionComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcFilterRowDefinitionComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcFilterRowDefinitionComponent, "observedAttributes", {
        get: function () {
            if (IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent == null) {
                var names = getAllPropertyNames(IgcFilterRowDefinitionComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent = names;
            }
            return IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcFilterRowDefinitionComponent.register = function () {
        if (!IgcFilterRowDefinitionComponent._isElementRegistered) {
            IgcFilterRowDefinitionComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcFilterRowDefinitionComponent.htmlTagName, IgcFilterRowDefinitionComponent);
        }
    };
    Object.defineProperty(IgcFilterRowDefinitionComponent.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = +v;
            this._a("paddingLeft", this.i.er);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcFilterRowDefinitionComponent.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.et;
        },
        set: function (v) {
            this.i.et = +v;
            this._a("paddingTop", this.i.et);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcFilterRowDefinitionComponent.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.es;
        },
        set: function (v) {
            this.i.es = +v;
            this._a("paddingRight", this.i.es);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcFilterRowDefinitionComponent.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.eq;
        },
        set: function (v) {
            this.i.eq = +v;
            this._a("paddingBottom", this.i.eq);
        },
        enumerable: false,
        configurable: true
    });
    IgcFilterRowDefinitionComponent._observedAttributesIgcFilterRowDefinitionComponent = null;
    IgcFilterRowDefinitionComponent.htmlTagName = "igc-filter-row-definition";
    IgcFilterRowDefinitionComponent._isElementRegistered = false;
    return IgcFilterRowDefinitionComponent;
}(IgcDefinitionBaseComponent));
export { IgcFilterRowDefinitionComponent };
