import { IgcGridCellPosition } from "./igc-grid-cell-position";
import { GridActiveCellChangedEventArgs as GridActiveCellChangedEventArgs_internal } from "./GridActiveCellChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
var IgcGridActiveCellChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcGridActiveCellChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcGridActiveCellChangedEventArgs.prototype.createImplementation = function () {
        return new GridActiveCellChangedEventArgs_internal();
    };
    Object.defineProperty(IgcGridActiveCellChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridActiveCellChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcGridActiveCellChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcGridActiveCellChangedEventArgs.prototype, "newActiveCell", {
        /**
         * The new active cell.
        */
        get: function () {
            var r = this.i.newActiveCell;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcGridCellPosition();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.newActiveCell = null : this.i.newActiveCell = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridActiveCellChangedEventArgs.prototype, "oldActiveCell", {
        /**
         * The old active cell.
        */
        get: function () {
            var r = this.i.oldActiveCell;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcGridCellPosition();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.oldActiveCell = null : this.i.oldActiveCell = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgcGridActiveCellChangedEventArgs;
}());
export { IgcGridActiveCellChangedEventArgs };
