import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { GridCellEditStartedEventArgs as GridCellEditStartedEventArgs_internal } from "./GridCellEditStartedEventArgs";
var IgcGridCellEditStartedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcGridCellEditStartedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcGridCellEditStartedEventArgs.prototype.createImplementation = function () {
        return new GridCellEditStartedEventArgs_internal();
    };
    Object.defineProperty(IgcGridCellEditStartedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridCellEditStartedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcGridCellEditStartedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcGridCellEditStartedEventArgs.prototype, "column", {
        /**
         * Gets the column of the cell that started editing.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcDataGridColumnComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridCellEditStartedEventArgs.prototype, "row", {
        /**
         * Gets the row index of the cell that started editing.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridCellEditStartedEventArgs.prototype, "item", {
        /**
         * Gets the row item.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgcGridCellEditStartedEventArgs;
}());
export { IgcGridCellEditStartedEventArgs };
