import { GridCellPosition as GridCellPosition_internal } from "./GridCellPosition";
var IgcGridCellPosition = /** @class */ /*@__PURE__*/ (function () {
    function IgcGridCellPosition() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcGridCellPosition.prototype.createImplementation = function () {
        return new GridCellPosition_internal();
    };
    Object.defineProperty(IgcGridCellPosition.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridCellPosition.prototype.onImplementationCreated = function () {
    };
    IgcGridCellPosition.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcGridCellPosition.prototype, "rowIndex", {
        /**
         * Gets or sets the row position of the cell.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridCellPosition.prototype, "columnUniqueKey", {
        /**
         * Gets or sets the column position of the cell.  Can be null for spanning elements like section headers.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridCellPosition.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgcGridCellPosition;
}());
export { IgcGridCellPosition };
