import { __extends } from "tslib";
import { NamePatcher, toSpinal, getAllPropertyNames } from "igniteui-webcomponents-core";
import { WebComponentRenderer } from "igniteui-webcomponents-core";
import { DataGridStylingDefaults } from './DataGridStylingDefaults';
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { GridColumnGroupOptions } from "./GridColumnGroupOptions";
import { IgcGridColumnOptionsSimpleSectionBaseComponent } from "./igc-grid-column-options-simple-section-base-component";
var IgcGridColumnGroupOptionsComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcGridColumnGroupOptionsComponent, _super);
    function IgcGridColumnGroupOptionsComponent() {
        var _this = _super.call(this) || this;
        _this._disconnected = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._webComponentRenderer = new WebComponentRenderer(_this, document, true, DataGridStylingDefaults);
        _this._webComponentWrapper = _this._webComponentRenderer.createElement("div");
        _this._webComponentRenderer.updateRoot(_this._webComponentWrapper);
        //this._webComponentRenderer.rootWrapper.append(this._webComponentWrapper);
        _this._webComponentWrapper.setStyleProperty("display", "block");
        _this._webComponentWrapper.setStyleProperty("width", "100%");
        _this._webComponentWrapper.setStyleProperty("height", "100%");
        _this.i.provideRenderer(_this._webComponentRenderer);
        return _this;
    }
    Object.defineProperty(IgcGridColumnGroupOptionsComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridColumnGroupOptionsComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
        },
        enumerable: false,
        configurable: true
    });
    // supports angular themes or custom properties set in CSS
    IgcGridColumnGroupOptionsComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcGridColumnGroupOptionsComponent.prototype.destroy = function () {
        this._implementation.destroy();
        this._webComponentRenderer.destroy();
    };
    IgcGridColumnGroupOptionsComponent.prototype.createImplementation = function () {
        return new GridColumnGroupOptions();
    };
    Object.defineProperty(IgcGridColumnGroupOptionsComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnGroupOptionsComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
    };
    IgcGridColumnGroupOptionsComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            return;
        }
        this.classList.add("ig-grid-column-group-options");
        this.classList.add("igc-grid-column-group-options");
        this.appendChild(this._webComponentRenderer.rootWrapper.getNativeElement());
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS
        this._styling(this, this);
        this.afterContentInit();
    };
    IgcGridColumnGroupOptionsComponent.prototype.afterContentInit = function () {
    };
    Object.defineProperty(IgcGridColumnGroupOptionsComponent, "observedAttributes", {
        get: function () {
            if (IgcGridColumnGroupOptionsComponent._observedAttributesIgcGridColumnGroupOptionsComponent == null) {
                var names = getAllPropertyNames(IgcGridColumnGroupOptionsComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGridColumnGroupOptionsComponent._observedAttributesIgcGridColumnGroupOptionsComponent = names;
            }
            return IgcGridColumnGroupOptionsComponent._observedAttributesIgcGridColumnGroupOptionsComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnGroupOptionsComponent.register = function () {
        if (!IgcGridColumnGroupOptionsComponent._isElementRegistered) {
            IgcGridColumnGroupOptionsComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcGridColumnGroupOptionsComponent.htmlTagName, IgcGridColumnGroupOptionsComponent);
        }
    };
    IgcGridColumnGroupOptionsComponent._observedAttributesIgcGridColumnGroupOptionsComponent = null;
    IgcGridColumnGroupOptionsComponent.htmlTagName = "igc-grid-column-group-options";
    IgcGridColumnGroupOptionsComponent._isElementRegistered = false;
    return IgcGridColumnGroupOptionsComponent;
}(IgcGridColumnOptionsSimpleSectionBaseComponent));
export { IgcGridColumnGroupOptionsComponent };
