import { __extends } from "tslib";
import { NamePatcher, toSpinal, getAllPropertyNames } from "igniteui-webcomponents-core";
import { WebComponentRenderer } from "igniteui-webcomponents-core";
import { DataGridStylingDefaults } from './DataGridStylingDefaults';
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { GridColumnHideOptions } from "./GridColumnHideOptions";
import { IgcGridColumnOptionsSimpleSectionBaseComponent } from "./igc-grid-column-options-simple-section-base-component";
var IgcGridColumnHideOptionsComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcGridColumnHideOptionsComponent, _super);
    function IgcGridColumnHideOptionsComponent() {
        var _this = _super.call(this) || this;
        _this._disconnected = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._webComponentRenderer = new WebComponentRenderer(_this, document, true, DataGridStylingDefaults);
        _this._webComponentWrapper = _this._webComponentRenderer.createElement("div");
        _this._webComponentRenderer.updateRoot(_this._webComponentWrapper);
        //this._webComponentRenderer.rootWrapper.append(this._webComponentWrapper);
        _this._webComponentWrapper.setStyleProperty("display", "block");
        _this._webComponentWrapper.setStyleProperty("width", "100%");
        _this._webComponentWrapper.setStyleProperty("height", "100%");
        _this.i.provideRenderer(_this._webComponentRenderer);
        return _this;
    }
    Object.defineProperty(IgcGridColumnHideOptionsComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridColumnHideOptionsComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
        },
        enumerable: false,
        configurable: true
    });
    // supports angular themes or custom properties set in CSS
    IgcGridColumnHideOptionsComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcGridColumnHideOptionsComponent.prototype.destroy = function () {
        this._implementation.destroy();
        this._webComponentRenderer.destroy();
    };
    IgcGridColumnHideOptionsComponent.prototype.createImplementation = function () {
        return new GridColumnHideOptions();
    };
    Object.defineProperty(IgcGridColumnHideOptionsComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnHideOptionsComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
    };
    IgcGridColumnHideOptionsComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            return;
        }
        this.classList.add("ig-grid-column-hide-options");
        this.classList.add("igc-grid-column-hide-options");
        this.appendChild(this._webComponentRenderer.rootWrapper.getNativeElement());
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS
        this._styling(this, this);
        this.afterContentInit();
    };
    IgcGridColumnHideOptionsComponent.prototype.afterContentInit = function () {
    };
    Object.defineProperty(IgcGridColumnHideOptionsComponent, "observedAttributes", {
        get: function () {
            if (IgcGridColumnHideOptionsComponent._observedAttributesIgcGridColumnHideOptionsComponent == null) {
                var names = getAllPropertyNames(IgcGridColumnHideOptionsComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGridColumnHideOptionsComponent._observedAttributesIgcGridColumnHideOptionsComponent = names;
            }
            return IgcGridColumnHideOptionsComponent._observedAttributesIgcGridColumnHideOptionsComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnHideOptionsComponent.register = function () {
        if (!IgcGridColumnHideOptionsComponent._isElementRegistered) {
            IgcGridColumnHideOptionsComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcGridColumnHideOptionsComponent.htmlTagName, IgcGridColumnHideOptionsComponent);
        }
    };
    IgcGridColumnHideOptionsComponent._observedAttributesIgcGridColumnHideOptionsComponent = null;
    IgcGridColumnHideOptionsComponent.htmlTagName = "igc-grid-column-hide-options";
    IgcGridColumnHideOptionsComponent._isElementRegistered = false;
    return IgcGridColumnHideOptionsComponent;
}(IgcGridColumnOptionsSimpleSectionBaseComponent));
export { IgcGridColumnHideOptionsComponent };
