import { __extends } from "tslib";
import { NamePatcher, toSpinal, getAllPropertyNames } from "igniteui-webcomponents-core";
import { WebComponentRenderer } from "igniteui-webcomponents-core";
import { DataGridStylingDefaults } from './DataGridStylingDefaults';
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { GridColumnMoveOptions } from "./GridColumnMoveOptions";
import { IgcGridColumnOptionsSimpleSectionBaseComponent } from "./igc-grid-column-options-simple-section-base-component";
var IgcGridColumnMoveOptionsComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcGridColumnMoveOptionsComponent, _super);
    function IgcGridColumnMoveOptionsComponent() {
        var _this = _super.call(this) || this;
        _this._disconnected = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._webComponentRenderer = new WebComponentRenderer(_this, document, true, DataGridStylingDefaults);
        _this._webComponentWrapper = _this._webComponentRenderer.createElement("div");
        _this._webComponentRenderer.updateRoot(_this._webComponentWrapper);
        //this._webComponentRenderer.rootWrapper.append(this._webComponentWrapper);
        _this._webComponentWrapper.setStyleProperty("display", "block");
        _this._webComponentWrapper.setStyleProperty("width", "100%");
        _this._webComponentWrapper.setStyleProperty("height", "100%");
        _this.i.provideRenderer(_this._webComponentRenderer);
        return _this;
    }
    Object.defineProperty(IgcGridColumnMoveOptionsComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridColumnMoveOptionsComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
        },
        enumerable: false,
        configurable: true
    });
    // supports angular themes or custom properties set in CSS
    IgcGridColumnMoveOptionsComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcGridColumnMoveOptionsComponent.prototype.destroy = function () {
        this._implementation.destroy();
        this._webComponentRenderer.destroy();
    };
    IgcGridColumnMoveOptionsComponent.prototype.createImplementation = function () {
        return new GridColumnMoveOptions();
    };
    Object.defineProperty(IgcGridColumnMoveOptionsComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnMoveOptionsComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
    };
    IgcGridColumnMoveOptionsComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            return;
        }
        this.classList.add("ig-grid-column-move-options");
        this.classList.add("igc-grid-column-move-options");
        this.appendChild(this._webComponentRenderer.rootWrapper.getNativeElement());
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS
        this._styling(this, this);
        this.afterContentInit();
    };
    IgcGridColumnMoveOptionsComponent.prototype.afterContentInit = function () {
    };
    Object.defineProperty(IgcGridColumnMoveOptionsComponent, "observedAttributes", {
        get: function () {
            if (IgcGridColumnMoveOptionsComponent._observedAttributesIgcGridColumnMoveOptionsComponent == null) {
                var names = getAllPropertyNames(IgcGridColumnMoveOptionsComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGridColumnMoveOptionsComponent._observedAttributesIgcGridColumnMoveOptionsComponent = names;
            }
            return IgcGridColumnMoveOptionsComponent._observedAttributesIgcGridColumnMoveOptionsComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnMoveOptionsComponent.register = function () {
        if (!IgcGridColumnMoveOptionsComponent._isElementRegistered) {
            IgcGridColumnMoveOptionsComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcGridColumnMoveOptionsComponent.htmlTagName, IgcGridColumnMoveOptionsComponent);
        }
    };
    Object.defineProperty(IgcGridColumnMoveOptionsComponent.prototype, "moveLeftCaption", {
        get: function () {
            return this.i.b8;
        },
        set: function (v) {
            this.i.b8 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridColumnMoveOptionsComponent.prototype, "moveRightCaption", {
        get: function () {
            return this.i.cc;
        },
        set: function (v) {
            this.i.cc = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnMoveOptionsComponent._observedAttributesIgcGridColumnMoveOptionsComponent = null;
    IgcGridColumnMoveOptionsComponent.htmlTagName = "igc-grid-column-move-options";
    IgcGridColumnMoveOptionsComponent._isElementRegistered = false;
    return IgcGridColumnMoveOptionsComponent;
}(IgcGridColumnOptionsSimpleSectionBaseComponent));
export { IgcGridColumnMoveOptionsComponent };
