import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { IgcColumnWidth } from "./igc-column-width";
import { GridColumnWidthChangedEventArgs as GridColumnWidthChangedEventArgs_internal } from "./GridColumnWidthChangedEventArgs";
/**
 * Event arguments for the GridColumnWidthChanged event.
*/
var IgcGridColumnWidthChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcGridColumnWidthChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcGridColumnWidthChangedEventArgs.prototype.createImplementation = function () {
        return new GridColumnWidthChangedEventArgs_internal();
    };
    Object.defineProperty(IgcGridColumnWidthChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGridColumnWidthChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcGridColumnWidthChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcGridColumnWidthChangedEventArgs.prototype, "column", {
        /**
         * The column whose Width has changed
        */
        get: function () {
            var r = this.i.c;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcDataGridColumnComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridColumnWidthChangedEventArgs.prototype, "oldWidth", {
        /**
         * The old column width.
        */
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcColumnWidth();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGridColumnWidthChangedEventArgs.prototype, "newWidth", {
        /**
         * The new column width.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcColumnWidth();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgcGridColumnWidthChangedEventArgs;
}());
export { IgcGridColumnWidthChangedEventArgs };
