import { __extends } from "tslib";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { HeaderRowSeparator } from "./HeaderRowSeparator";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a Header Row separator. This is used to visually separate the header row from the rest of the rows in a grid.
*/
var IgcHeaderRowSeparatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcHeaderRowSeparatorComponent, _super);
    function IgcHeaderRowSeparatorComponent() {
        return _super.call(this) || this;
    }
    IgcHeaderRowSeparatorComponent.prototype.createImplementation = function () {
        return new HeaderRowSeparator();
    };
    Object.defineProperty(IgcHeaderRowSeparatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcHeaderRowSeparatorComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcHeaderRowSeparatorComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcHeaderRowSeparatorComponent, "observedAttributes", {
        get: function () {
            if (IgcHeaderRowSeparatorComponent._observedAttributesIgcHeaderRowSeparatorComponent == null) {
                var names = getAllPropertyNames(IgcHeaderRowSeparatorComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcHeaderRowSeparatorComponent._observedAttributesIgcHeaderRowSeparatorComponent = names;
            }
            return IgcHeaderRowSeparatorComponent._observedAttributesIgcHeaderRowSeparatorComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcHeaderRowSeparatorComponent.register = function () {
        if (!IgcHeaderRowSeparatorComponent._isElementRegistered) {
            IgcHeaderRowSeparatorComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcHeaderRowSeparatorComponent.htmlTagName, IgcHeaderRowSeparatorComponent);
        }
    };
    IgcHeaderRowSeparatorComponent._observedAttributesIgcHeaderRowSeparatorComponent = null;
    IgcHeaderRowSeparatorComponent.htmlTagName = "igc-header-row-separator";
    IgcHeaderRowSeparatorComponent._isElementRegistered = false;
    return IgcHeaderRowSeparatorComponent;
}(IgcDefinitionBaseComponent));
export { IgcHeaderRowSeparatorComponent };
