import { __extends } from "tslib";
import { ImageStretchOptions_$type } from "./ImageStretchOptions";
import { EditorType_$type } from "./EditorType";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { ImageColumn } from "./ImageColumn";
import { getAllPropertyNames, toSpinal, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
var IgcImageColumnComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcImageColumnComponent, _super);
    function IgcImageColumnComponent() {
        return _super.call(this) || this;
    }
    IgcImageColumnComponent.prototype.createImplementation = function () {
        return new ImageColumn();
    };
    Object.defineProperty(IgcImageColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcImageColumnComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcImageColumnComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcImageColumnComponent, "observedAttributes", {
        get: function () {
            if (IgcImageColumnComponent._observedAttributesIgcImageColumnComponent == null) {
                var names = getAllPropertyNames(IgcImageColumnComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcImageColumnComponent._observedAttributesIgcImageColumnComponent = names;
            }
            return IgcImageColumnComponent._observedAttributesIgcImageColumnComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcImageColumnComponent.register = function () {
        if (!IgcImageColumnComponent._isElementRegistered) {
            IgcImageColumnComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcImageColumnComponent.htmlTagName, IgcImageColumnComponent);
        }
    };
    Object.defineProperty(IgcImageColumnComponent.prototype, "imageStretchOption", {
        /**
         * Gets or sets the stretch option to use when rendering images
        */
        get: function () {
            return this.i.lp;
        },
        set: function (v) {
            this.i.lp = ensureEnum(ImageStretchOptions_$type, v);
            this._a("imageStretchOption", enumToString(ImageStretchOptions_$type, this.i.lp));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcImageColumnComponent.prototype, "editorType", {
        /**
         * Gets or sets the editor type used for editing cells in this column.
        */
        get: function () {
            return this.i.ll;
        },
        set: function (v) {
            this.i.ll = ensureEnum(EditorType_$type, v);
            this._a("editorType", enumToString(EditorType_$type, this.i.ll));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcImageColumnComponent.prototype, "editorDataSource", {
        /**
         * Gets or sets the ComboBox data source.
        */
        get: function () {
            return this.i.lq;
        },
        set: function (v) {
            this.i.lq = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcImageColumnComponent.prototype, "editorTextField", {
        /**
         * Gets or sets the ComboBox text field.
        */
        get: function () {
            return this.i.lr;
        },
        set: function (v) {
            this.i.lr = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcImageColumnComponent.prototype, "editorValueField", {
        /**
         * Gets or sets the ComboBox value field.
        */
        get: function () {
            return this.i.ls;
        },
        set: function (v) {
            this.i.ls = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcImageColumnComponent._observedAttributesIgcImageColumnComponent = null;
    IgcImageColumnComponent.htmlTagName = "igc-image-column";
    IgcImageColumnComponent._isElementRegistered = false;
    return IgcImageColumnComponent;
}(IgcDataGridColumnComponent));
export { IgcImageColumnComponent };
