import { PageChangedEventArgs as PageChangedEventArgs_internal } from "./PageChangedEventArgs";
var IgcPageChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcPageChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcPageChangedEventArgs.prototype.createImplementation = function () {
        return new PageChangedEventArgs_internal();
    };
    Object.defineProperty(IgcPageChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcPageChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcPageChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcPageChangedEventArgs.prototype, "page", {
        /**
         * Gets the index for the page that just changed.
        */
        get: function () {
            return this.i.page;
        },
        set: function (v) {
            this.i.page = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcPageChangedEventArgs.prototype, "data", {
        /**
         * Gets the data for the page that just changed.
        */
        get: function () {
            return this.i.data;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.data = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgcPageChangedEventArgs;
}());
export { IgcPageChangedEventArgs };
