import { __extends } from "tslib";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { RowSeparator } from "./RowSeparator";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
var IgcRowSeparatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcRowSeparatorComponent, _super);
    function IgcRowSeparatorComponent() {
        return _super.call(this) || this;
    }
    IgcRowSeparatorComponent.prototype.createImplementation = function () {
        return new RowSeparator();
    };
    Object.defineProperty(IgcRowSeparatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcRowSeparatorComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcRowSeparatorComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcRowSeparatorComponent, "observedAttributes", {
        get: function () {
            if (IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent == null) {
                var names = getAllPropertyNames(IgcRowSeparatorComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent = names;
            }
            return IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcRowSeparatorComponent.register = function () {
        if (!IgcRowSeparatorComponent._isElementRegistered) {
            IgcRowSeparatorComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcRowSeparatorComponent.htmlTagName, IgcRowSeparatorComponent);
        }
    };
    IgcRowSeparatorComponent._observedAttributesIgcRowSeparatorComponent = null;
    IgcRowSeparatorComponent.htmlTagName = "igc-row-separator";
    IgcRowSeparatorComponent._isElementRegistered = false;
    return IgcRowSeparatorComponent;
}(IgcDefinitionBaseComponent));
export { IgcRowSeparatorComponent };
