import { __extends } from "tslib";
import { GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgcCellInfo } from "./igc-cell-info";
import { SectionHeaderCellModel as SectionHeaderCellModel_internal } from "./SectionHeaderCellModel";
import { ensureEnum } from "igniteui-webcomponents-core";
/**
 * Backing information for a section header cell in the grid.
*/
var IgcSectionHeaderCellInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcSectionHeaderCellInfo, _super);
    function IgcSectionHeaderCellInfo() {
        return _super.call(this) || this;
    }
    IgcSectionHeaderCellInfo.prototype.createImplementation = function () {
        return new SectionHeaderCellModel_internal();
    };
    Object.defineProperty(IgcSectionHeaderCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderCellInfo.prototype, "resolvedText", {
        /**
         * Sets or gets the resolved text for the section header cell.
        */
        get: function () {
            return this.i.lz;
        },
        set: function (v) {
            this.i.lz = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderCellInfo.prototype, "resolvedSummaryText", {
        /**
         * Sets or gets the resolved summary text for the section header cell.
        */
        get: function () {
            return this.i.lx;
        },
        set: function (v) {
            this.i.lx = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderCellInfo.prototype, "summaryDisplayMode", {
        /**
         * Sets or gets how summaries are displayed in the section header cell.
        */
        get: function () {
            return this.i.lo;
        },
        set: function (v) {
            this.i.lo = ensureEnum(GroupSummaryDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgcSectionHeaderCellInfo;
}(IgcCellInfo));
export { IgcSectionHeaderCellInfo };
