import { __extends } from "tslib";
import { GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { SectionHeader } from "./SectionHeader";
import { getAllPropertyNames, toSpinal, brushToString, stringToBrush, ensureBool, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Used to configure the appearance of the section header cells.
*/
var IgcSectionHeaderComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcSectionHeaderComponent, _super);
    function IgcSectionHeaderComponent() {
        return _super.call(this) || this;
    }
    IgcSectionHeaderComponent.prototype.createImplementation = function () {
        return new SectionHeader();
    };
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcSectionHeaderComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcSectionHeaderComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcSectionHeaderComponent, "observedAttributes", {
        get: function () {
            if (IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent == null) {
                var names = getAllPropertyNames(IgcSectionHeaderComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent = names;
            }
            return IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcSectionHeaderComponent.register = function () {
        if (!IgcSectionHeaderComponent._isElementRegistered) {
            IgcSectionHeaderComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcSectionHeaderComponent.htmlTagName, IgcSectionHeaderComponent);
        }
    };
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "selectedBackground", {
        get: function () {
            return brushToString(this.i.fg);
        },
        set: function (v) {
            this.i.fg = stringToBrush(v);
            this._a("selectedBackground", brushToString(this.i.fg));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "actualSelectedBackground", {
        get: function () {
            return brushToString(this.i.ff);
        },
        set: function (v) {
            this.i.ff = stringToBrush(v);
            this._a("actualSelectedBackground", brushToString(this.i.ff));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.ey;
        },
        set: function (v) {
            this.i.ey = +v;
            this._a("paddingLeft", this.i.ey);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.e0;
        },
        set: function (v) {
            this.i.e0 = +v;
            this._a("paddingTop", this.i.e0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.ez;
        },
        set: function (v) {
            this.i.ez = +v;
            this._a("paddingRight", this.i.ez);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.ex;
        },
        set: function (v) {
            this.i.ex = +v;
            this._a("paddingBottom", this.i.ex);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "isCollapsable", {
        get: function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = ensureBool(v);
            this._a("isCollapsable", this.i.er);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSectionHeaderComponent.prototype, "summaryDisplayMode", {
        get: function () {
            return this.i.eo;
        },
        set: function (v) {
            this.i.eo = ensureEnum(GroupSummaryDisplayMode_$type, v);
            this._a("summaryDisplayMode", enumToString(GroupSummaryDisplayMode_$type, this.i.eo));
        },
        enumerable: false,
        configurable: true
    });
    IgcSectionHeaderComponent._observedAttributesIgcSectionHeaderComponent = null;
    IgcSectionHeaderComponent.htmlTagName = "igc-section-header";
    IgcSectionHeaderComponent._isElementRegistered = false;
    return IgcSectionHeaderComponent;
}(IgcDefinitionBaseComponent));
export { IgcSectionHeaderComponent };
