import { __extends } from "tslib";
import { IgcCellInfo } from "./igc-cell-info";
import { SummaryCellModel as SummaryCellModel_internal } from "./SummaryCellModel";
import { brushToString, stringToBrush } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
/**
 * Backing information for a section header cell in the grid.
*/
var IgcSummaryCellInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcSummaryCellInfo, _super);
    function IgcSummaryCellInfo() {
        return _super.call(this) || this;
    }
    IgcSummaryCellInfo.prototype.createImplementation = function () {
        return new SummaryCellModel_internal();
    };
    Object.defineProperty(IgcSummaryCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryCellInfo.prototype, "resolvedSummaryLabel", {
        /**
         * Sets or gets the resolved summary label for the summary cell.
        */
        get: function () {
            return this.i.lr;
        },
        set: function (v) {
            this.i.lr = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryCellInfo.prototype, "resolvedSummaryValue", {
        /**
         * Sets or gets the resolved summary value for the sumamry cell.
        */
        get: function () {
            return this.i.lt;
        },
        set: function (v) {
            this.i.lt = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryCellInfo.prototype, "summaryLabelTextColor", {
        /**
         * Gets or sets the color of the text for the summary label in the cell.
        */
        get: function () {
            return brushToString(this.i.ly);
        },
        set: function (v) {
            this.i.ly = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryCellInfo.prototype, "font", {
        get: function () {
            if (this.i.lk == null) {
                return null;
            }
            return this.i.lk.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.lk = fi;
        },
        enumerable: false,
        configurable: true
    });
    return IgcSummaryCellInfo;
}(IgcCellInfo));
export { IgcSummaryCellInfo };
