import { SummaryChangedEventArgs as SummaryChangedEventArgs_internal } from "./SummaryChangedEventArgs";
import { ensureBool } from "igniteui-webcomponents-core";
/**
 * Event args for the SummaryChanged event.
*/
var IgcSummaryChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcSummaryChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcSummaryChangedEventArgs.prototype.createImplementation = function () {
        return new SummaryChangedEventArgs_internal();
    };
    Object.defineProperty(IgcSummaryChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcSummaryChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcSummaryChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcSummaryChangedEventArgs.prototype, "iD", {
        /**
         * Gets the unique ID for the changed summary.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryChangedEventArgs.prototype, "isEnabled", {
        /**
         * Gets the current state of the changed summary.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgcSummaryChangedEventArgs;
}());
export { IgcSummaryChangedEventArgs };
