import { __extends } from "tslib";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { getAllPropertyNames, toSpinal, brushToString, stringToBrush } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
var IgcSummaryRowComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcSummaryRowComponent, _super);
    function IgcSummaryRowComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgcSummaryRowComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcSummaryRowComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcSummaryRowComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcSummaryRowComponent, "observedAttributes", {
        get: function () {
            if (IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent == null) {
                var names = getAllPropertyNames(IgcSummaryRowComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent = names;
            }
            return IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "selectedBackground", {
        /**
         * Gets or sets the background color for summary cells when selected.
        */
        get: function () {
            return brushToString(this.i.fj);
        },
        set: function (v) {
            this.i.fj = stringToBrush(v);
            this._a("selectedBackground", brushToString(this.i.fj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "actualSelectedBackground", {
        /**
         * Gets the actual background color for summary cells when selected.
        */
        get: function () {
            return brushToString(this.i.fg);
        },
        set: function (v) {
            this.i.fg = stringToBrush(v);
            this._a("actualSelectedBackground", brushToString(this.i.fg));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "summaryLabelTextColor", {
        /**
         * Gets or sets the text color for the summary labels.
        */
        get: function () {
            return brushToString(this.i.fk);
        },
        set: function (v) {
            this.i.fk = stringToBrush(v);
            this._a("summaryLabelTextColor", brushToString(this.i.fk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "actualSummaryLabelTextColor", {
        /**
         * Gets the actual text color for the summary labels.
        */
        get: function () {
            return brushToString(this.i.fh);
        },
        set: function (v) {
            this.i.fh = stringToBrush(v);
            this._a("actualSummaryLabelTextColor", brushToString(this.i.fh));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "summaryNameTextStyle", {
        /**
         * Gets or sets the text style for the summary labels.
        */
        get: function () {
            if (this.i.summaryNameTextStyle == null) {
                return null;
            }
            return this.i.summaryNameTextStyle.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.summaryNameTextStyle = fi;
            this._a("summaryNameTextStyle", this.i.summaryNameTextStyle != null ? this.i.summaryNameTextStyle.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.ew;
        },
        set: function (v) {
            this.i.ew = +v;
            this._a("paddingLeft", this.i.ew);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.ey;
        },
        set: function (v) {
            this.i.ey = +v;
            this._a("paddingTop", this.i.ey);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.ex;
        },
        set: function (v) {
            this.i.ex = +v;
            this._a("paddingRight", this.i.ex);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcSummaryRowComponent.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.ev;
        },
        set: function (v) {
            this.i.ev = +v;
            this._a("paddingBottom", this.i.ev);
        },
        enumerable: false,
        configurable: true
    });
    IgcSummaryRowComponent._observedAttributesIgcSummaryRowComponent = null;
    return IgcSummaryRowComponent;
}(IgcDefinitionBaseComponent));
export { IgcSummaryRowComponent };
