import { TemplateHeaderCellUpdatingEventArgs as TemplateHeaderCellUpdatingEventArgs_internal } from "./TemplateHeaderCellUpdatingEventArgs";
import { IgcDateTimeCellInfo } from "./igc-date-time-cell-info";
import { IgcImageCellInfo } from "./igc-image-cell-info";
import { IgcNumericCellInfo } from "./igc-numeric-cell-info";
import { IgcRowSeparatorInfo } from "./igc-row-separator-info";
import { IgcSectionHeaderCellInfo } from "./igc-section-header-cell-info";
import { IgcTemplateCellInfo } from "./igc-template-cell-info";
import { IgcTemplateHeaderCellInfo } from "./igc-template-header-cell-info";
import { IgcTemplateSectionHeaderCellInfo } from "./igc-template-section-header-cell-info";
import { IgcTextCellInfo } from "./igc-text-cell-info";
import { IgcTextHeaderCellInfo } from "./igc-text-header-cell-info";
/**
 * Information about the header cell that has content which is being created or updated.
*/
var IgcTemplateHeaderCellUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcTemplateHeaderCellUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgcTemplateHeaderCellUpdatingEventArgs.prototype.createImplementation = function () {
        return new TemplateHeaderCellUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgcTemplateHeaderCellUpdatingEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcTemplateHeaderCellUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcTemplateHeaderCellUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgcTemplateHeaderCellUpdatingEventArgs.prototype, "isCanvasBased", {
        get: function () {
            return this.i.content.isCanvasBased;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTemplateHeaderCellUpdatingEventArgs.prototype, "content", {
        /**
         * The host in which to add or update content if this is a DOM based cell.
        */
        get: function () {
            if (this.isCanvasBased) {
                return null;
            }
            else {
                return this.i.content.element.getNativeElement();
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTemplateHeaderCellUpdatingEventArgs.prototype, "context", {
        get: function () {
            if (this.isCanvasBased) {
                return this.i.content.templateContext;
            }
            else {
                return null;
            }
        },
        enumerable: false,
        configurable: true
    });
    IgcTemplateHeaderCellUpdatingEventArgs.prototype.ensureCorrectSize = function () {
        return this.i.content.ensureCorrectSize();
    };
    IgcTemplateHeaderCellUpdatingEventArgs.prototype.renderStandardBackground = function () {
        this.i.content.renderStandardBackground();
    };
    IgcTemplateHeaderCellUpdatingEventArgs.prototype.renderStandardContent = function () {
        this.i.content.renderStandardContent();
    };
    Object.defineProperty(IgcTemplateHeaderCellUpdatingEventArgs.prototype, "cellInfo", {
        /**
         * The backing information for the current cell.
        */
        get: function () {
            if (this.i.cellInfo == null) {
                return null;
            }
            if (!this.i.cellInfo.externalObject) {
                var ext = null;
                switch (this.i.cellInfo.$type.name) {
                    case "DateTimeCellModel":
                        ext = new IgcDateTimeCellInfo();
                        break;
                    case "ImageCellModel":
                        ext = new IgcImageCellInfo();
                        break;
                    case "NumericCellModel":
                        ext = new IgcNumericCellInfo();
                        break;
                    case "RowSeparatorModel":
                        ext = new IgcRowSeparatorInfo();
                        break;
                    case "SectionHeaderCellModel":
                        ext = new IgcSectionHeaderCellInfo();
                        break;
                    case "TemplateCellModel":
                        ext = new IgcTemplateCellInfo();
                        break;
                    case "TemplateHeaderCellModel":
                        ext = new IgcTemplateHeaderCellInfo();
                        break;
                    case "TemplateSectionHeaderCellModel":
                        ext = new IgcTemplateSectionHeaderCellInfo();
                        break;
                    case "TextCellModel":
                        ext = new IgcTextCellInfo();
                        break;
                    case "TextHeaderCellModel":
                        ext = new IgcTextHeaderCellInfo();
                        break;
                }
                ext._implementation = this.i.cellInfo;
                this.i.cellInfo.externalObject = ext;
            }
            return this.i.cellInfo.externalObject;
        },
        enumerable: false,
        configurable: true
    });
    return IgcTemplateHeaderCellUpdatingEventArgs;
}());
export { IgcTemplateHeaderCellUpdatingEventArgs };
