import { __extends } from "tslib";
import { EditorType_$type } from "./EditorType";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { TextColumn } from "./TextColumn";
import { getAllPropertyNames, toSpinal, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
var IgcTextColumnComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcTextColumnComponent, _super);
    function IgcTextColumnComponent() {
        return _super.call(this) || this;
    }
    IgcTextColumnComponent.prototype.createImplementation = function () {
        return new TextColumn();
    };
    Object.defineProperty(IgcTextColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcTextColumnComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcTextColumnComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcTextColumnComponent, "observedAttributes", {
        get: function () {
            if (IgcTextColumnComponent._observedAttributesIgcTextColumnComponent == null) {
                var names = getAllPropertyNames(IgcTextColumnComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcTextColumnComponent._observedAttributesIgcTextColumnComponent = names;
            }
            return IgcTextColumnComponent._observedAttributesIgcTextColumnComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcTextColumnComponent.register = function () {
        if (!IgcTextColumnComponent._isElementRegistered) {
            IgcTextColumnComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcTextColumnComponent.htmlTagName, IgcTextColumnComponent);
        }
    };
    Object.defineProperty(IgcTextColumnComponent.prototype, "editorType", {
        /**
         * Gets or sets the editor type used for editing cells in this column.
        */
        get: function () {
            return this.i.ll;
        },
        set: function (v) {
            this.i.ll = ensureEnum(EditorType_$type, v);
            this._a("editorType", enumToString(EditorType_$type, this.i.ll));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextColumnComponent.prototype, "editorDataSource", {
        /**
         * Gets or sets the ComboBox data source.
        */
        get: function () {
            return this.i.lm;
        },
        set: function (v) {
            this.i.lm = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextColumnComponent.prototype, "editorTextField", {
        /**
         * Gets or sets the ComboBox text field.
        */
        get: function () {
            return this.i.lo;
        },
        set: function (v) {
            this.i.lo = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextColumnComponent.prototype, "editorValueField", {
        /**
         * Gets or sets the ComboBox value field.
        */
        get: function () {
            return this.i.lp;
        },
        set: function (v) {
            this.i.lp = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcTextColumnComponent._observedAttributesIgcTextColumnComponent = null;
    IgcTextColumnComponent.htmlTagName = "igc-text-column";
    IgcTextColumnComponent._isElementRegistered = false;
    return IgcTextColumnComponent;
}(IgcDataGridColumnComponent));
export { IgcTextColumnComponent };
