import { __extends } from "tslib";
import { SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { ColumnOptionsIconAlignment_$type } from "./ColumnOptionsIconAlignment";
import { ColumnOptionsIconBehavior_$type } from "./ColumnOptionsIconBehavior";
import { IgcTextCellInfo } from "./igc-text-cell-info";
import { TextHeaderCellModel as TextHeaderCellModel_internal } from "./TextHeaderCellModel";
import { ensureBool, ensureEnum, brushToString, stringToBrush } from "igniteui-webcomponents-core";
/**
 * Backing information for a text header cell.
*/
var IgcTextHeaderCellInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcTextHeaderCellInfo, _super);
    function IgcTextHeaderCellInfo() {
        return _super.call(this) || this;
    }
    IgcTextHeaderCellInfo.prototype.createImplementation = function () {
        return new TextHeaderCellModel_internal();
    };
    Object.defineProperty(IgcTextHeaderCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextHeaderCellInfo.prototype, "isColumnOptionsEnabled", {
        /**
         * Sets or gets whether the filter UI should be visible in the header.
        */
        get: function () {
            return this.i.lu;
        },
        set: function (v) {
            this.i.lu = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextHeaderCellInfo.prototype, "sortIndicatorStyle", {
        get: function () {
            return this.i.ls;
        },
        set: function (v) {
            this.i.ls = ensureEnum(SortIndicatorStyle_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextHeaderCellInfo.prototype, "columnOptionsIconAlignment", {
        /**
         * Gets or sets the alignment of the column options icon within the header cell.
        */
        get: function () {
            return this.i.lo;
        },
        set: function (v) {
            this.i.lo = ensureEnum(ColumnOptionsIconAlignment_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextHeaderCellInfo.prototype, "columnOptionsIconColor", {
        /**
         * Gets or sets the color for the column options icon in the header.
        */
        get: function () {
            return brushToString(this.i.l6);
        },
        set: function (v) {
            this.i.l6 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTextHeaderCellInfo.prototype, "columnOptionsIconBehavior", {
        /**
         * Gets or sets how the column option icon will behave in the header.
        */
        get: function () {
            return this.i.lq;
        },
        set: function (v) {
            this.i.lq = ensureEnum(ColumnOptionsIconBehavior_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgcTextHeaderCellInfo;
}(IgcTextCellInfo));
export { IgcTextHeaderCellInfo };
