import { __extends } from "tslib";
import { IgcHeaderComponent } from "./igc-header-component";
import { TextHeader } from "./TextHeader";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Represents a class used to configure the appearance of a text column header cells.
*/
var IgcTextHeaderComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcTextHeaderComponent, _super);
    function IgcTextHeaderComponent() {
        return _super.call(this) || this;
    }
    IgcTextHeaderComponent.prototype.createImplementation = function () {
        return new TextHeader();
    };
    Object.defineProperty(IgcTextHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcTextHeaderComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcTextHeaderComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcTextHeaderComponent, "observedAttributes", {
        get: function () {
            if (IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent == null) {
                var names = getAllPropertyNames(IgcTextHeaderComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent = names;
            }
            return IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcTextHeaderComponent.register = function () {
        if (!IgcTextHeaderComponent._isElementRegistered) {
            IgcTextHeaderComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcTextHeaderComponent.htmlTagName, IgcTextHeaderComponent);
        }
    };
    IgcTextHeaderComponent._observedAttributesIgcTextHeaderComponent = null;
    IgcTextHeaderComponent.htmlTagName = "igc-text-header";
    IgcTextHeaderComponent._isElementRegistered = false;
    return IgcTextHeaderComponent;
}(IgcHeaderComponent));
export { IgcTextHeaderComponent };
