import { CellKey as CellKey_internal } from "./CellKey";
import { IgcPrimaryKeyValue } from './igc-primary-key-value';
import { IgcDataGridColumnComponent } from './igc-data-grid-column-component';
/**
 * An indentifier for a specific cell in the grid.
*/
export declare class IgcCellKey {
    protected _implementation: any;
    private _primaryKey;
    get i(): CellKey_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the primary key of the row associated with the cell.
    */
    get primaryKey(): IgcPrimaryKeyValue;
    set primaryKey(v: IgcPrimaryKeyValue);
    /**
 * Gets or sets the row data object associated with the cell.
*/
    get rowItem(): any;
    set rowItem(v: any);
    /**
     * Gets or sets the column name associated with the cell.
     * All columns in the grid must have a unique name. That unique name is what is used for this property.
    */
    get columnUniqueKey(): string;
    set columnUniqueKey(v: string);
    /**
     * Gets or sets the resolved column object associated with this cell.
    */
    get resolvedColumn(): IgcDataGridColumnComponent;
    findByName(name: string): any;
}
