import { IgcColumnGroupDescription } from "./igc-column-group-description";
import { ColumnGroupDescriptionCollection as ColumnGroupDescriptionCollection_internal } from "./ColumnGroupDescriptionCollection";
/**
 * Represents a collection of grouping elements that are applied to a data source or provider.
*/
export declare class IgcColumnGroupDescriptionCollection {
    protected createImplementation(): ColumnGroupDescriptionCollection_internal;
    protected _implementation: any;
    get i(): ColumnGroupDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgcColumnGroupDescription): IgcColumnGroupDescription;
    get count(): number;
    toArray(): IgcColumnGroupDescription[];
    [Symbol.iterator](): Generator<any, void, unknown>;
    /**
 * Gets or sets whether this collection should detach the sync when the target collection changes.
*/
    get shouldDetachOnTargetChange(): boolean;
    set shouldDetachOnTargetChange(v: boolean);
    findByName(name: string): any;
    add(item: IgcColumnGroupDescription): boolean;
    insert(index: number, item: IgcColumnGroupDescription): void;
    clear(): void;
    indexOf(item: IgcColumnGroupDescription): number;
    remove(item: IgcColumnGroupDescription): boolean;
    removeAt(index: number): IgcColumnGroupDescription;
}
