import { ColumnGrouping } from './ColumnGrouping';
import { IgcDataGridComponent } from "./igc-data-grid-component";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
export declare class IgcColumnGroupingComponent extends IgcHTMLElement {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _container;
    private _renderer;
    constructor();
    updateStyle(): void;
    destroy(): void;
    protected createImplementation(): ColumnGrouping;
    private _columnGrouping;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ColumnGrouping; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcColumnGroupingComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcColumnGroupingComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get targetGrid(): IgcDataGridComponent;
    set targetGrid(v: IgcDataGridComponent);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get title(): string;
    set title(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get titleColor(): string;
    set titleColor(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get iconColor(): string;
    set iconColor(v: string);
    /**
     * Gets or sets the background color of the column items in the group area.
    */
    get itemBackgroundColor(): string;
    set itemBackgroundColor(v: string);
    /**
     * Gets or sets the background color of the column items when hovered by the mouse.
    */
    get itemHoverBackgroundColor(): string;
    set itemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the background of the group by area.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Exports visual information about the current state of the grid.

*/
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
