import { IgcColumnSortDescription } from "./igc-column-sort-description";
import { ColumnSortDescriptionCollection as ColumnSortDescriptionCollection_internal } from "./ColumnSortDescriptionCollection";
/**
 * Represents a collection of sort elements that are applied to a data source or provider.
*/
export declare class IgcColumnSortDescriptionCollection {
    protected createImplementation(): ColumnSortDescriptionCollection_internal;
    protected _implementation: any;
    get i(): ColumnSortDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgcColumnSortDescription): IgcColumnSortDescription;
    get count(): number;
    toArray(): IgcColumnSortDescription[];
    [Symbol.iterator](): Generator<any, void, unknown>;
    /**
 * Gets or sets whether this collection should detach the sync when the target collection changes.
*/
    get shouldDetachOnTargetChange(): boolean;
    set shouldDetachOnTargetChange(v: boolean);
    findByName(name: string): any;
    add(item: IgcColumnSortDescription): boolean;
    insert(index: number, item: IgcColumnSortDescription): void;
    clear(): void;
    indexOf(item: IgcColumnSortDescription): number;
    remove(item: IgcColumnSortDescription): boolean;
    removeAt(index: number): IgcColumnSortDescription;
}
