import { IDataSource } from "igniteui-webcomponents-core";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { ComboBoxColumn } from "./ComboBoxColumn";
/**
 * A combobox column.
*/
export declare class IgcComboBoxColumnComponent extends IgcDataGridColumnComponent {
    protected createImplementation(): ComboBoxColumn;
    /**
                                 * @hidden
                                 */
    get i(): ComboBoxColumn;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcComboBoxColumnComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets the actual data source that is being used by the combo. If a collection was provided for the combobox data, an implicit LocalDataSource is created, and this is available via this property.
    */
    get actualDataSource(): IDataSource;
    set actualDataSource(v: IDataSource);
    /**
     * Gets or sets the ComboBox data source.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets or sets the ComboBox text field.
    */
    get textField(): string;
    set textField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get valueField(): string;
    set valueField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get valueMultiField(): string[];
    set valueMultiField(v: string[]);
}
