import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { IgcGridFilterDialogOpeningEventArgs } from "./igc-grid-filter-dialog-opening-event-args";
import { IgcGridFilterDialogFilterChangeEventArgs } from "./igc-grid-filter-dialog-filter-change-event-args";
import { IgcFilterDialogRenderCompletedEventArgs } from "./igc-filter-dialog-render-completed-event-args";
import { GridFilterDialog } from "./GridFilterDialog";
/**
 * An advanced grid for displaying data.
*/
export declare class IgcDataGridFilterDialogComponent extends IgcHTMLElement {
    protected createImplementation(): GridFilterDialog;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): GridFilterDialog; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcDataGridFilterDialogComponent;
    private onImplementationCreated;
    constructor();
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcDataGridFilterDialogComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    get isAnimationEnabled(): boolean;
    set isAnimationEnabled(v: boolean);
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio(): number;
    set pixelScalingRatio(v: number);
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualPixelScalingRatio(): number;
    set actualPixelScalingRatio(v: number);
    get iconColor(): string;
    set iconColor(v: string);
    get viewSize(): number;
    set viewSize(v: number);
    get isOpen(): boolean;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    notifySizeChanged(width: number, height: number): void;
    notifyCellSizeChanged(): void;
    showIcon(): void;
    hideIcon(): void;
    private _dialogOpening;
    private _dialogOpening_wrapped;
    get dialogOpening(): (s: IgcDataGridFilterDialogComponent, e: IgcGridFilterDialogOpeningEventArgs) => void;
    set dialogOpening(ev: (s: IgcDataGridFilterDialogComponent, e: IgcGridFilterDialogOpeningEventArgs) => void);
    private _filterChanging;
    private _filterChanging_wrapped;
    get filterChanging(): (s: IgcDataGridFilterDialogComponent, e: IgcGridFilterDialogFilterChangeEventArgs) => void;
    set filterChanging(ev: (s: IgcDataGridFilterDialogComponent, e: IgcGridFilterDialogFilterChangeEventArgs) => void);
    private _filterChanged;
    private _filterChanged_wrapped;
    get filterChanged(): (s: IgcDataGridFilterDialogComponent, e: IgcGridFilterDialogFilterChangeEventArgs) => void;
    set filterChanged(ev: (s: IgcDataGridFilterDialogComponent, e: IgcGridFilterDialogFilterChangeEventArgs) => void);
    private _renderCompleted;
    private _renderCompleted_wrapped;
    get renderCompleted(): (s: IgcDataGridFilterDialogComponent, e: IgcFilterDialogRenderCompletedEventArgs) => void;
    set renderCompleted(ev: (s: IgcDataGridFilterDialogComponent, e: IgcFilterDialogRenderCompletedEventArgs) => void);
}
