import { IDataSource } from "igniteui-webcomponents-core";
import { Pager } from "./Pager";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { IgcDataGridComponent } from "./igc-data-grid-component";
import { IgcPageChangedEventArgs } from "./igc-page-changed-event-args";
export declare class IgcDataGridPagerComponent extends IgcHTMLElement {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    protected createImplementation(): Pager;
    protected _implementation: any;
    get i(): Pager;
    private onImplementationCreated;
    private _contentInitialized;
    private _renderer;
    constructor();
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    private containerResized;
    private afterContentInit;
    get actualDataSource(): IDataSource;
    private _dataSource;
    /**
     * Gets or sets the data used by the pager.
     * */
    set dataSource(value: any);
    get dataSource(): any;
    /**
     * Gets or sets the target grid for the pager.
     * */
    set targetGrid(value: IgcDataGridComponent);
    get targetGrid(): IgcDataGridComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcDataGridPagerComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    get pagerText(): string;
    set pagerText(v: string);
    /**
     * Gets or sets the page size.
    */
    get pageSize(): number;
    set pageSize(v: number);
    /**
     * Gets the page count.
    */
    get pageCount(): number;
    set pageCount(v: number);
    /**
     * Gets or sets the current page for the pager.
    */
    get currentPage(): number;
    set currentPage(v: number);
    /**
     * Gets or sets the font to use for content cells
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the background color to use.
    */
    get background(): string;
    set background(v: string);
    /**
     * Gets or sets the border color around the grid.
    */
    get border(): string;
    set border(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    nextPage(): void;
    previousPage(): void;
    firstPage(): void;
    lastPage(): void;
    provideContainer(container: any): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _pageChanged;
    private _pageChanged_wrapped;
    /**
     * Event called when the page has changed.
    */
    get pageChanged(): (s: IgcDataGridPagerComponent, e: IgcPageChangedEventArgs) => void;
    set pageChanged(ev: (s: IgcDataGridPagerComponent, e: IgcPageChangedEventArgs) => void);
}
