import { DataGridToolbar } from './DataGridToolbar';
import { IgcDataGridComponent } from "./igc-data-grid-component";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
export declare class IgcDataGridToolbarComponent extends IgcHTMLElement {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _container;
    private _renderer;
    constructor();
    updateStyle(): void;
    destroy(): void;
    protected createImplementation(): DataGridToolbar;
    private _toolbar;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DataGridToolbar; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcDataGridToolbarComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcDataGridToolbarComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get targetGrid(): IgcDataGridComponent;
    set targetGrid(v: IgcDataGridComponent);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get toolbarTitle(): string;
    set toolbarTitle(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get toolbarTitleStyle(): string;
    set toolbarTitleStyle(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get toolbarTitleColor(): string;
    set toolbarTitleColor(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get dialogBackgroundColor(): string;
    set dialogBackgroundColor(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get columnChooser(): boolean;
    set columnChooser(v: boolean);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get columnChooserText(): string;
    set columnChooserText(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get columnChooserTitle(): string;
    set columnChooserTitle(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get columnPinning(): boolean;
    set columnPinning(v: boolean);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get columnPinningText(): string;
    set columnPinningText(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get columnPinningTitle(): string;
    set columnPinningTitle(v: string);
    get borderWidthBottom(): number;
    set borderWidthBottom(v: number);
    get borderWidthLeft(): number;
    set borderWidthLeft(v: number);
    get borderWidthRight(): number;
    set borderWidthRight(v: number);
    get borderWidthTop(): number;
    set borderWidthTop(v: number);
    ensureBorderWidth(): void;
    /**
     * Gets or Sets the property name that contains the values.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Exports visual information about the current state of the toolbar.

*/
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
