import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { FilterRowDefinition } from "./FilterRowDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export declare class IgcFilterRowDefinitionComponent extends IgcDefinitionBaseComponent {
    protected createImplementation(): FilterRowDefinition;
    /**
                                 * @hidden
                                 */
    get i(): FilterRowDefinition;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcFilterRowDefinitionComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
}
