import { GridEasingFunctionType } from "./GridEasingFunctionType";
import { GridAnimationPhaseSettings as GridAnimationPhaseSettings_internal } from "./GridAnimationPhaseSettings";
/**
 * This class is used to group the settings to define an animation phase.
*/
export declare class IgcGridAnimationPhaseSettings {
    protected createImplementation(): GridAnimationPhaseSettings_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): GridAnimationPhaseSettings_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The duration of an animation, in milliseconds
    */
    get durationMilliseconds(): number;
    set durationMilliseconds(v: number);
    /**
     * The amount of time to delay an animation, in milliseconds.
    */
    get holdInitialMilliseconds(): number;
    set holdInitialMilliseconds(v: number);
    /**
     * The amount of time to delay each item animating, in milliseconds
    */
    get perItemDelayMilliseconds(): number;
    set perItemDelayMilliseconds(v: number);
    /**
     * The amount of time each item animating should take, in milliseconds
    */
    get subItemDurationMilliseconds(): number;
    set subItemDurationMilliseconds(v: number);
    /**
     * The desired amount of time each item animating should take, in milliseconds
    */
    get desiredSubItemDurationMilliseconds(): number;
    set desiredSubItemDurationMilliseconds(v: number);
    /**
     * Configures whether all items animating should finish simultaneously
    */
    get shouldItemsFinishSimultaneously(): boolean;
    set shouldItemsFinishSimultaneously(v: boolean);
    /**
     * Configures the Easing function used to animate the individual items
    */
    get easingFunctionType(): GridEasingFunctionType;
    set easingFunctionType(v: GridEasingFunctionType);
    findByName(name: string): any;
}
