import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { GridColumnOptionsBase } from "./GridColumnOptionsBase";
export declare abstract class IgcGridColumnOptionsBaseComponent extends IgcHTMLElement {
    protected createImplementation(): GridColumnOptionsBase;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): GridColumnOptionsBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcGridColumnOptionsBaseComponent;
    private onImplementationCreated;
    constructor();
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcGridColumnOptionsBaseComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    /**
     * Gets or sets the autoSize for which this AutoSizeOptions will apply.
    */
    get autoSize(): boolean;
    set autoSize(v: boolean);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the base built in theme to use for the component.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets the actual display baseTheme to use for the component.
    */
    get actualBaseTheme(): BaseControlTheme;
    set actualBaseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    get buttonDensity(): ControlDisplayDensity;
    set buttonDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display buttonDensity to use for the component.
    */
    get actualButtonDensity(): ControlDisplayDensity;
    set actualButtonDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the font to use for buttons.
    */
    get buttonTextStyle(): string;
    set buttonTextStyle(v: string);
    /**
     * Gets or sets the column for which this ColumnOptions will apply.
    */
    get column(): IgcDataGridColumnComponent;
    set column(v: IgcDataGridColumnComponent);
    /**
     * Gets or sets the display density to use for the component.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display density to use for the component.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the font to use for labels.
    */
    get labelTextStyle(): string;
    set labelTextStyle(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
