import { GridColumnOptions } from "./GridColumnOptions";
import { IgcGridColumnOptionsBaseComponent } from "./igc-grid-column-options-base-component";
import { IgcApplyButtonClickEventArgs } from './igc-apply-button-click-event-args';
import { IgcCancelButtonClickEventArgs } from './igc-cancel-button-click-event-args';
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
export declare class IgcGridColumnOptionsComponent extends IgcGridColumnOptionsBaseComponent {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _webComponentWrapper;
    private _webComponentRenderer;
    constructor();
    updateStyle(): void;
    destroy(): void;
    protected createImplementation(): GridColumnOptions;
    get i(): GridColumnOptions;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    private static _observedAttributesIgcGridColumnOptionsComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    get headerOptionsVisibleResolved(): boolean;
    get sortOptionsVisibleResolved(): boolean;
    get moveOptionsVisibleResolved(): boolean;
    get pinOptionsVisibleResolved(): boolean;
    get hideOptionsVisibleResolved(): boolean;
    get groupOptionsVisibleResolved(): boolean;
    get filterOptionsVisibleResolved(): boolean;
    get summaryOptionsVisibleResolved(): boolean;
    /**
     * Gets or sets the font to use for columnNames.
    */
    get columnNameTextStyle(): string;
    set columnNameTextStyle(v: string);
    /**
     * Gets or sets the amount of left padding to use for the left edge of the component.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of left padding to use for the top edge of the component.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of left padding to use for the right edge of the component.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of left padding to use for the bottom edge of the component.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
    get headerVisible(): boolean;
    set headerVisible(v: boolean);
    get sortOptionsVisible(): boolean;
    set sortOptionsVisible(v: boolean);
    get moveOptionsVisible(): boolean;
    set moveOptionsVisible(v: boolean);
    get pinOptionsVisible(): boolean;
    set pinOptionsVisible(v: boolean);
    get hideOptionsVisible(): boolean;
    set hideOptionsVisible(v: boolean);
    get groupOptionsVisible(): boolean;
    set groupOptionsVisible(v: boolean);
    get filterOptionsVisible(): boolean;
    set filterOptionsVisible(v: boolean);
    get summaryOptionsVisible(): boolean;
    set summaryOptionsVisible(v: boolean);
    get sortHeaderCaption(): string;
    set sortHeaderCaption(v: string);
    get sortAscendingCaption(): string;
    set sortAscendingCaption(v: string);
    get sortDescendingCaption(): string;
    set sortDescendingCaption(v: string);
    get moveHeaderCaption(): string;
    set moveHeaderCaption(v: string);
    get moveLeftCaption(): string;
    set moveLeftCaption(v: string);
    get moveRightCaption(): string;
    set moveRightCaption(v: string);
    get pinHeaderCaption(): string;
    set pinHeaderCaption(v: string);
    get pinLeftCaption(): string;
    set pinLeftCaption(v: string);
    get pinRightCaption(): string;
    set pinRightCaption(v: string);
    get applyFiltersButtonCaption(): string;
    set applyFiltersButtonCaption(v: string);
    get cancelFiltersButtonCaption(): string;
    set cancelFiltersButtonCaption(v: string);
    get clearColumnFiltersCaption(): string;
    set clearColumnFiltersCaption(v: string);
    /**
     * Gets or sets the display density to use for the summary list menu.
    */
    get summaryListDensity(): ControlDisplayDensity;
    set summaryListDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display density used for the summary list menu.
    */
    get actualSummaryListDensity(): ControlDisplayDensity;
    set actualSummaryListDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    get filterListDensity(): ControlDisplayDensity;
    set filterListDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display filterListDensity to use for the component.
    */
    get actualFilterListDensity(): ControlDisplayDensity;
    set actualFilterListDensity(v: ControlDisplayDensity);
    get filterListPlaceholderText(): string;
    set filterListPlaceholderText(v: string);
    /**
     * Gets or sets the text color for the summary options menu.
    */
    get summaryListTextColor(): string;
    set summaryListTextColor(v: string);
    /**
     * Gets or sets the background color for the summary options menu.
    */
    get summaryListBackground(): string;
    set summaryListBackground(v: string);
    private _applyButtonClick;
    private _applyButtonClick_wrapped;
    get applyButtonClick(): (s: IgcGridColumnOptionsComponent, e: IgcApplyButtonClickEventArgs) => void;
    set applyButtonClick(ev: (s: IgcGridColumnOptionsComponent, e: IgcApplyButtonClickEventArgs) => void);
    private _cancelButtonClick;
    private _cancelButtonClick_wrapped;
    get cancelButtonClick(): (s: IgcGridColumnOptionsComponent, e: IgcCancelButtonClickEventArgs) => void;
    set cancelButtonClick(ev: (s: IgcGridColumnOptionsComponent, e: IgcCancelButtonClickEventArgs) => void);
}
