import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { Header } from "./Header";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export declare abstract class IgcHeaderComponent extends IgcDefinitionBaseComponent {
    /**
                                 * @hidden
                                 */
    get i(): Header;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcHeaderComponent;
    static get observedAttributes(): string[];
    /**
     * Gets or sets the color to use for the sort indicator icon
    */
    get sortIndicatorColor(): string;
    set sortIndicatorColor(v: string);
    /**
     * Gets the actual background color that is used for the cells when they are selected
    */
    get actualSortIndicatorColor(): string;
    set actualSortIndicatorColor(v: string);
    get sortIndicatorStyle(): SortIndicatorStyle;
    set sortIndicatorStyle(v: SortIndicatorStyle);
    get actualSortIndicatorStyle(): SortIndicatorStyle;
    set actualSortIndicatorStyle(v: SortIndicatorStyle);
    /**
     * Gets or sets the amount of left padding to use for the cell content.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of top padding to use for the cell content.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of right padding to use for the cell content.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of bottom padding to use for the cell content.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
}
