import { ImageStretchOptions } from "./ImageStretchOptions";
import { EditorType } from "./EditorType";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { ImageColumn } from "./ImageColumn";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
export declare class IgcImageColumnComponent extends IgcDataGridColumnComponent {
    protected createImplementation(): ImageColumn;
    /**
                                 * @hidden
                                 */
    get i(): ImageColumn;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcImageColumnComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets the stretch option to use when rendering images
    */
    get imageStretchOption(): ImageStretchOptions;
    set imageStretchOption(v: ImageStretchOptions);
    /**
     * Gets or sets the editor type used for editing cells in this column.
    */
    get editorType(): EditorType;
    set editorType(v: EditorType);
    /**
     * Gets or sets the ComboBox data source.
    */
    get editorDataSource(): any;
    set editorDataSource(v: any);
    /**
     * Gets or sets the ComboBox text field.
    */
    get editorTextField(): string;
    set editorTextField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get editorValueField(): string;
    set editorValueField(v: string);
}
