import { MultiColumnComboBox } from "./MultiColumnComboBox";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { SortMode } from './SortMode';
import { IDataSource } from "igniteui-webcomponents-core";
import { IgcMultiColumnComboBoxTextChangedEventArgs } from './igc-multi-column-combo-box-text-changed-event-args';
import { IgcMultiColumnComboBoxValueChangedEventArgs } from './igc-multi-column-combo-box-value-changed-event-args';
import { IgcGotFocusEventArgs } from './igc-got-focus-event-args';
import { IgcLostFocusEventArgs } from './igc-lost-focus-event-args';
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { IgcKeyEventArgs } from "igniteui-webcomponents-core";
import { IgcInputChangeEventArgs } from "igniteui-webcomponents-inputs";
import { IgcColumnWidth } from './igc-column-width';
export declare class IgcMultiColumnComboBoxComponent extends IgcHTMLElement {
    private _implementation;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _webComponentWrapper;
    private _webComponentRenderer;
    private _portalManager;
    constructor();
    updateStyle(): void;
    destroy(): void;
    protected createImplementation(): MultiColumnComboBox;
    get i(): MultiColumnComboBox;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    /**
     * Gets or sets the default column width to use if a column as no local width.
     * */
    get defaultColumnWidth(): IgcColumnWidth;
    set defaultColumnWidth(value: IgcColumnWidth);
    private attributeSynced;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcMultiColumnComboBoxComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the ShowClearButton property to detirmine if the clear button is shown
*/
    get showClearButton(): boolean;
    set showClearButton(v: boolean);
    /**
     * Gets or sets the desired properties for the data source to load. If specified the data source may decide to constrain the properties it fetches to these properties and must make sure that at least those properties are loaded, rather than the default behavior for that data source.
    */
    get fields(): string[];
    set fields(v: string[]);
    /**
     * Gets or sets the background color to use for the input group.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets the actual opacity to use for the underline ripple element.
    */
    get actualBackgroundColor(): string;
    set actualBackgroundColor(v: string);
    /**
     * Gets or sets the base built in theme to use for the component.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets the actual display baseTheme to use for the component.
    */
    get actualBaseTheme(): BaseControlTheme;
    set actualBaseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the color to use the border of the input group.
    */
    get borderColor(): string;
    set borderColor(v: string);
    /**
     * Gets the actual item background color.
    */
    get actualBorderColor(): string;
    set actualBorderColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group.
    */
    get borderWidth(): number;
    set borderWidth(v: number);
    /**
     * Gets the actual item border width.
    */
    get actualBorderWidth(): number;
    set actualBorderWidth(v: number);
    /**
     * Gets or sets the visibility of the drop down button.
    */
    get columnHeadersVisible(): boolean;
    set columnHeadersVisible(v: boolean);
    get contentPaddingBottom(): number;
    set contentPaddingBottom(v: number);
    get contentPaddingLeft(): number;
    set contentPaddingLeft(v: number);
    get contentPaddingRight(): number;
    set contentPaddingRight(v: number);
    get contentPaddingTop(): number;
    set contentPaddingTop(v: number);
    ensureContentPadding(): void;
    get actualContentPaddingBottom(): number;
    set actualContentPaddingBottom(v: number);
    get actualContentPaddingLeft(): number;
    set actualContentPaddingLeft(v: number);
    get actualContentPaddingRight(): number;
    set actualContentPaddingRight(v: number);
    get actualContentPaddingTop(): number;
    set actualContentPaddingTop(v: number);
    ensureActualContentPadding(): void;
    get cornerRadiusBottomRight(): number;
    set cornerRadiusBottomRight(v: number);
    get cornerRadiusBottomLeft(): number;
    set cornerRadiusBottomLeft(v: number);
    get cornerRadiusTopLeft(): number;
    set cornerRadiusTopLeft(v: number);
    get cornerRadiusTopRight(): number;
    set cornerRadiusTopRight(v: number);
    ensureCornerRadius(): void;
    get actualCornerRadiusBottomRight(): number;
    set actualCornerRadiusBottomRight(v: number);
    get actualCornerRadiusBottomLeft(): number;
    set actualCornerRadiusBottomLeft(v: number);
    get actualCornerRadiusTopLeft(): number;
    set actualCornerRadiusTopLeft(v: number);
    get actualCornerRadiusTopRight(): number;
    set actualCornerRadiusTopRight(v: number);
    ensureActualCornerRadius(): void;
    /**
     * Gets or sets the desired properties for the data source to load. If specified the data source may decide to constrain the properties it fetches to these properties and must make sure that at least those properties are loaded, rather than the default behavior for that data source.
    */
    get dataSourceDesiredProperties(): string[];
    set dataSourceDesiredProperties(v: string[]);
    /**
     * Gets or sets the display Density to use for the buttons and dropdown grid.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display Density to use for the component.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the visibility of the drop down button.
    */
    get dropDownButtonVisible(): boolean;
    set dropDownButtonVisible(v: boolean);
    /**
     * Gets or sets the color to use the hovered background of the inputs in the group.
    */
    get focusBorderColor(): string;
    set focusBorderColor(v: string);
    /**
     * Gets the actual item border color.
    */
    get actualFocusBorderColor(): string;
    set actualFocusBorderColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when focused.
    */
    get focusBorderWidth(): number;
    set focusBorderWidth(v: number);
    /**
     * Gets the actual item border width.
    */
    get actualFocusBorderWidth(): number;
    set actualFocusBorderWidth(v: number);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get focusUnderlineColor(): string;
    set focusUnderlineColor(v: string);
    /**
     * Gets the actual color to use for the underline element when focused.
    */
    get actualFocusUnderlineColor(): string;
    set actualFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get focusUnderlineOpacity(): number;
    set focusUnderlineOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline element when focused.
    */
    get actualFocusUnderlineOpacity(): number;
    set actualFocusUnderlineOpacity(v: number);
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused.
    */
    get focusUnderlineRippleOpacity(): number;
    set focusUnderlineRippleOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline ripple element when focused.
    */
    get actualFocusUnderlineRippleOpacity(): number;
    set actualFocusUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get hoverUnderlineColor(): string;
    set hoverUnderlineColor(v: string);
    /**
     * Gets the actual color to use for the underline element.
    */
    get actualHoverUnderlineColor(): string;
    set actualHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get hoverUnderlineOpacity(): number;
    set hoverUnderlineOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline element when hovered.
    */
    get actualHoverUnderlineOpacity(): number;
    set actualHoverUnderlineOpacity(v: number);
    /**
     * Gets or sets the width to use for the underline element when hovered.
    */
    get hoverUnderlineWidth(): number;
    set hoverUnderlineWidth(v: number);
    /**
     * Gets the width to use for the underline element when hovered.
    */
    get actualHoverUnderlineWidth(): number;
    set actualHoverUnderlineWidth(v: number);
    /**
     * Gets or sets the data to which to bind the combo box list. This can be some type of array or list, or it can
     * be an IDataSource instance.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets the actual data source that is being used by the combo box list. If a collection was provided for the combo box data, an implicit LocalDataSource has been created, and this is available via this property.
    */
    get actualDataSource(): IDataSource;
    /**
     * The text displayed in the label portion of the control.
    */
    get label(): string;
    set label(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get labelTextColor(): string;
    set labelTextColor(v: string);
    /**
     * Gets the actual color to use for the text color.
    */
    get actualLabelTextColor(): string;
    set actualLabelTextColor(v: string);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get labelTextStyle(): string;
    set labelTextStyle(v: string);
    /**
     * Gets or sets the visibility of the label.
    */
    get actualLabelVisible(): boolean;
    set actualLabelVisible(v: boolean);
    /**
     * Gets or sets the text to display on the list when no suggested matches are found.
    */
    get noMatchesFoundLabel(): string;
    set noMatchesFoundLabel(v: string);
    /**
     * Gets the actual text to display on the list when no suggested matches are found.
    */
    get actualNoMatchesFoundLabel(): string;
    set actualNoMatchesFoundLabel(v: string);
    /**
     * Gets or sets the color to use for the "no matches found" label.
    */
    get noMatchesFoundLabelBackgroundColor(): string;
    set noMatchesFoundLabelBackgroundColor(v: string);
    /**
     * Gets the actual color to use for the "no matches found" label.
    */
    get actualNoMatchesFoundLabelBackgroundColor(): string;
    set actualNoMatchesFoundLabelBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the "no matches found" label.
    */
    get noMatchesFoundLabelTextColor(): string;
    set noMatchesFoundLabelTextColor(v: string);
    /**
     * Gets the actual color to use for the "no matches found" label.
    */
    get actualNoMatchesFoundLabelTextColor(): string;
    set actualNoMatchesFoundLabelTextColor(v: string);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get noMatchesFoundLabelTextStyle(): string;
    set noMatchesFoundLabelTextStyle(v: string);
    /**
     * Placeholder text which gives the user a hint about what kind of text is expected.
    */
    get placeholder(): string;
    set placeholder(v: string);
    /**
     * Gets or sets the visibility of the row separators in the drop down.
    */
    get rowSeparatorsVisible(): boolean;
    set rowSeparatorsVisible(v: boolean);
    /**
     * Gets or sets the color to use for the text.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets the actual color to use for the text color.
    */
    get actualTextColor(): string;
    set actualTextColor(v: string);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get underlineColor(): string;
    set underlineColor(v: string);
    /**
     * Gets the actual color to use for the underline element.
    */
    get actualUnderlineColor(): string;
    set actualUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get underlineOpacity(): number;
    set underlineOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline element.
    */
    get actualUnderlineOpacity(): number;
    set actualUnderlineOpacity(v: number);
    /**
     * Gets or sets the color to use for the underline ripple element.
    */
    get underlineRippleColor(): string;
    set underlineRippleColor(v: string);
    /**
     * Gets the actual color to use for the underline ripple element.
    */
    get actualUnderlineRippleColor(): string;
    set actualUnderlineRippleColor(v: string);
    /**
     * Gets or sets the opacity to use for the underline ripple element.
    */
    get underlineRippleOpacity(): number;
    set underlineRippleOpacity(v: number);
    /**
     * Gets the actual opacity to use for the underline ripple element.
    */
    get actualUnderlineRippleOpacity(): number;
    set actualUnderlineRippleOpacity(v: number);
    /**
     * Gets or sets the width to use for the underline element.
    */
    get underlineRippleWidth(): number;
    set underlineRippleWidth(v: number);
    /**
     * Gets the actual width to use for the underline element.
    */
    get actualUnderlineRippleWidth(): number;
    set actualUnderlineRippleWidth(v: number);
    /**
     * Gets or sets the width to use for the underline element.
    */
    get underlineWidth(): number;
    set underlineWidth(v: number);
    /**
     * Gets the actual width to use for the underline element.
    */
    get actualUnderlineWidth(): number;
    set actualUnderlineWidth(v: number);
    /**
     * Whether to allow filtering of the combo
    */
    get allowFilter(): boolean;
    set allowFilter(v: boolean);
    /**
     * Returns/sets the action to take when a column header is clicked.
    */
    get sortMode(): SortMode;
    set sortMode(v: SortMode);
    /**
     * Determines the name of the field in the data source will be used as the Text of the MultiColumnComboBox.
    */
    get textField(): string;
    set textField(v: string);
    /**
     * The text displayed in the edit portion of the control.
    */
    get text(): string;
    set text(v: string);
    /**
     * Sets or gets the user provided primary key to assume for the data. Certain functionality of the combo (such as the the current Value) requires
     * a way to uniquely identify items in order to work correctly.
     * If a primary key cannot be inferred from the data source, you may need to provide one here.
    */
    get valueField(): string[];
    set valueField(v: string[]);
    /**
     * Gets the actual name of the field in the data source will be used as the Value of the MultiColumnComboBox.
    */
    get actualValueField(): string[];
    set actualValueField(v: string[]);
    /**
     * Gets or sets the Value of the combo.
     * When the user selects an item from, the value is set based on the specified ValueField field. If not ValueField is specified, then the first field in the data source is used.
     * When the user enters text into the combo, the list is searched based on the TextField field. If a matching string is found, the Value of the combo is the value of the ValueField field in the same row.
     * If the text entered in the combo does not match any item on the list, then the value will return null.
    */
    get value(): any;
    set value(v: any);
    /**
     * Indicates that the dropdown will position itself relative to the window instead of the document.
    */
    get isFixed(): boolean;
    set isFixed(v: boolean);
    /**
     * Indicates that the dropdown should open as a child of the combobox.
    */
    get openAsChild(): boolean;
    set openAsChild(v: boolean);
    /**
     * Indicates that the dropdown will place itself into the browser top layer.
    */
    get useTopLayer(): boolean;
    set useTopLayer(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Programmatically closes the list.

*/
    closeUp(): void;
    /**
     * Programmatically drops down the list.
    
    */
    dropDown(): void;
    /**
     * Selects all the text in the combo input area.
    
    */
    select(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _gotFocus;
    private _gotFocus_wrapped;
    get gotFocus(): (s: IgcMultiColumnComboBoxComponent, e: IgcGotFocusEventArgs) => void;
    set gotFocus(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcGotFocusEventArgs) => void);
    private _lostFocus;
    private _lostFocus_wrapped;
    get lostFocus(): (s: IgcMultiColumnComboBoxComponent, e: IgcLostFocusEventArgs) => void;
    set lostFocus(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcLostFocusEventArgs) => void);
    private _textValueChanged;
    private _textValueChanged_wrapped;
    get textValueChanged(): (s: IgcMultiColumnComboBoxComponent, e: IgcMultiColumnComboBoxTextChangedEventArgs) => void;
    set textValueChanged(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcMultiColumnComboBoxTextChangedEventArgs) => void);
    private _selectedValueChanged;
    private _selectedValueChanged_wrapped;
    get selectedValueChanged(): (s: IgcMultiColumnComboBoxComponent, e: IgcMultiColumnComboBoxValueChangedEventArgs) => void;
    set selectedValueChanged(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcMultiColumnComboBoxValueChangedEventArgs) => void);
    private _keyDown;
    private _keyDown_wrapped;
    get keyDown(): (s: IgcMultiColumnComboBoxComponent, e: IgcKeyEventArgs) => void;
    set keyDown(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcKeyEventArgs) => void);
    private _change;
    private _change_wrapped;
    get change(): (s: IgcMultiColumnComboBoxComponent, e: IgcInputChangeEventArgs) => void;
    set change(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcInputChangeEventArgs) => void);
    private _changing;
    private _changing_wrapped;
    get changing(): (s: IgcMultiColumnComboBoxComponent, e: IgcInputChangeEventArgs) => void;
    set changing(ev: (s: IgcMultiColumnComboBoxComponent, e: IgcInputChangeEventArgs) => void);
    private _textChange;
    private _textChange_wrapped;
    get textChange(): (s: IgcMultiColumnComboBoxComponent, e: string) => void;
    set textChange(ev: (s: IgcMultiColumnComboBoxComponent, e: string) => void);
    private _valueChange;
    private _valueChange_wrapped;
    get valueChange(): (s: IgcMultiColumnComboBoxComponent, e: any) => void;
    set valueChange(ev: (s: IgcMultiColumnComboBoxComponent, e: any) => void);
}
