import { IgcColumnPropertySetter } from "./igc-column-property-setter";
import { IgcColumnExchanger } from "./igc-column-exchanger";
import { ResponsivePhase as ResponsivePhase_internal } from "./ResponsivePhase";
/**
 * Describes one phase of a responsive state to apply to the grid.
*/
export declare class IgcResponsivePhase {
    protected createImplementation(): ResponsivePhase_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ResponsivePhase_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The name of this responsive phase
    */
    get name(): string;
    set name(v: string);
    /**
     * The amount of time to delay the responsive phase from starting, in milliseconds
    */
    get delayMilliseconds(): number;
    set delayMilliseconds(v: number);
    findByName(name: string): any;
    /**
     * Adds a column property setter to the phase.
    
    * @param setter  * The setter to add.
    */
    addColumnPropertySetter(setter: IgcColumnPropertySetter): IgcResponsivePhase;
    /**
     * Adds a column property setter to the phase, and returns it.
    
    */
    columnPropertySetter(): IgcColumnPropertySetter;
    /**
     * Adds a column exchanger the the phase.
    
    * @param exchanger  * The exchanger to add.
    */
    addColumnExchanger(exchanger: IgcColumnExchanger): IgcResponsivePhase;
    /**
     * Adds a column exchanger to the phase and returns it.
    
    */
    columnExchanger(): IgcResponsivePhase;
}
