import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { IgcDefinitionBaseComponent } from "./igc-definition-base-component";
import { SectionHeader } from "./SectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export declare class IgcSectionHeaderComponent extends IgcDefinitionBaseComponent {
    protected createImplementation(): SectionHeader;
    /**
                                 * @hidden
                                 */
    get i(): SectionHeader;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcSectionHeaderComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    get selectedBackground(): string;
    set selectedBackground(v: string);
    get actualSelectedBackground(): string;
    set actualSelectedBackground(v: string);
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
    get isCollapsable(): boolean;
    set isCollapsable(v: boolean);
    get summaryDisplayMode(): GroupSummaryDisplayMode;
    set summaryDisplayMode(v: GroupSummaryDisplayMode);
}
