import { EditorType } from "./EditorType";
import { IgcDataGridColumnComponent } from "./igc-data-grid-column-component";
import { TextColumn } from "./TextColumn";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export declare class IgcTextColumnComponent extends IgcDataGridColumnComponent {
    protected createImplementation(): TextColumn;
    /**
                                 * @hidden
                                 */
    get i(): TextColumn;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcTextColumnComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets the editor type used for editing cells in this column.
    */
    get editorType(): EditorType;
    set editorType(v: EditorType);
    /**
     * Gets or sets the ComboBox data source.
    */
    get editorDataSource(): any;
    set editorDataSource(v: any);
    /**
     * Gets or sets the ComboBox text field.
    */
    get editorTextField(): string;
    set editorTextField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get editorValueField(): string;
    set editorValueField(v: string);
}
